

FUNCTION get_src_name, srcname, verbose=verbose

  ; Look for HD or HR numbers for the targets

n_src = n_elements(srcname)
name = strarr(n_src)
For lp3=0, n_src-1 do begin

    src_tmp = strpos(srcname[lp3], '*')
    src_tmp2 = strpos(srcname[lp3], '?')
    if src_tmp ne -1 then srcname[lp3] = strmid(srcname[lp3], 0, src_tmp) 
    if src_tmp2 ne -1 then srcname[lp3] = strmid(srcname[lp3], 0, src_tmp2)


    ; First, query HR catolog
   
    if keyword_set(verbose) then print, 'Quering HR ...'
    src_info = QueryVizier('HR', srcname[lp3], 0.2, /all)
    if datatype(src_info) ne 'STC' then $
       src_info = QueryVizier('HR', srcname[lp3], 0.5, /all)

    if datatype(src_info) eq 'STC' then begin
      if n_elements(src_info.hr) gt 1 then begin
        src_ind = where(src_info._r eq min(src_info._r))
        name[lp3] = 'HR'+ strtrim(string(src_info[src_ind].hr),2)
      endif else name[lp3] =  'HR'+ strtrim(string(src_info.hr),2)
    endif else begin

       ; HR not exist, query HD
     if keyword_set(verbose) then  print, 'HR not exist, Quering HD ..'
       src_info = QueryVizier('HDE', srcname[lp3], 5, /all)
       if datatype(src_info) eq 'STC' then begin
          src_ind = where(src_info._r eq min(src_info._r))
          name[lp3] = 'HD'+strtrim(string(src_info[src_ind].hd),2)
       endif else begin
          
         ; HD not exist, query IRC

       if keyword_set(verbose) then  print, 'HD not exist, Quering IRC...'
         src_info = QueryVizier('IRC', srcname[lp3], 5, /all)
         if datatype(src_info) eq 'STC' then begin
             src_ind = where(src_info._r eq min(src_info._r))
            name[lp3] = 'IRC'+strtrim(string(src_info[src_ind].irc),2)
         endif else name[lp3]='---'
   
       endelse
    endelse

    print, srcname[lp3], ' = ', name[lp3]
endfor

Return, strtrim(string(name),2)

END


