
Function lst2ct, lst, lon, timezone, day, mon, year

; Purpose  : Convert Local Sidereal Time to Civil Time for a given date
;
; Input    : lst, Local Sidereal Time
;            lon, Longitude of the site
;            timezone, Timezone of the site. NOTE the day time saving time !!!!!!!
;                                            5 for EST, 4 for EDT (day light saving)
;            day, mon, year
;
; Output   : cvtime, the civil time for given date.
;
; MZ, 08/11/05


time0 = 0d		; use midnight 0:0:0 as reference time point.

CT2LST, lst0, lon, timezone, time0, day, mon, year  ; calculate lst at 0:0:0 civil time

Dlst = lst0-lst 

cvtime = (time0 - Dlst) mod 24.

;print, 'LST2CT: ', cvtime
if cvtime lt 0. then cvtime =24.+ cvtime 
if cvtime ge 24. then cvtime =cvtime-24.0

return, cvtime

end
