
pro mplan_get_Tname, Tname, POPname, Tname_arr=Tname_arr,Tname2=Tname2, popname2=popname2, $; OUTPUTS 
                     tele=tele, pops=pops                  ; INPUTS

; OUTPUT:   Tname        e.g., 'S1 E1 W1 W2'
;           POPname      e.g., '4 3 2 1' , corresponding to Tname
;           Tname_arr    e.g., ['S1', 'E1', 'W1', 'W2']
;           Tname2       e.g., 'S1E1W1W2'
;           S1 E1 W1 W2  e.g., '4321'


              Tele_names=['S1','S2','E1','E2','W1','W2']

              Tele_ind=where(tele eq 1, cnt)
              Tname_arr = Tele_names[Tele_ind]
              Tname=''
              popname=''
              Tname2=''
              popname2=''

              for lp=0, cnt-1 do begin
                  Tname+=Tele_names[Tele_ind[lp]]+' ' 
                  popname+=strtrim(string(pops[Tele_ind[lp]]),2)+' '
  
                  Tname2+=Tele_names[Tele_ind[lp]]
                  popname2+=strtrim(string(pops[Tele_ind[lp]]),2)
              endfor

end

;---------------------------------------------------------------

PRO mplan_event, event


Tele_names=['S1','S2','E1','E2','W1','W2']
Tele_id   =[ 0,   1,   2,   3,   4,   5  ]

widget_control, event.id, get_uvalue=uvalue

widget_control, event.top, get_uvalue=Pinfo

info = *Pinfo

widget_control, event.id, get_uvalue=widget

Case widget of
     'Tab'   : begin
                 if (event.tab eq 1) and (info.values.input1 ne '') then begin
                    
                    restore, 'read_src_temp1.idl'
                    data = read_ascii(info.values.input1, template=temp1)
                    data_ra = strmid(data.ra_dec, 0, 13)
                    data_dec = strmid(data.ra_dec, 14,27)         
                    data_name = data.name
                    tab_info={data_ra:data_ra, data_dec:data_dec, data_name:data_name}

                    if ptr_valid(Ptab_info) then ptr_free, Ptab_info
                    
                    ; save the Tab_info to a pointer and send it to info.values
                    info.values.tabinfo = ptr_new(tab_info,/no_copy)
              
                    ; Load values and initialize the Tab

		    info.values.target_ind= 0
                    widget_control, info.target, set_value=data_name
                    widget_control, info.target, set_combobox_select=info.values.target_ind
                    widget_control, info.ra, set_value=data_ra[info.values.target_ind]
                    widget_control, info.dec, set_value=data_dec[info.values.target_ind]
                    info.values.target = data_name[info.values.target_ind]
                 endif else if (event.tab eq 0) then wset,0
               end
     'Help1' : begin
             ;print, 'Help1'
             help1_text=['Help: 1. Input target info, ',$
                         '         or if target list has been inputted in Tab1, select a target from the drop list',$
                         '      2. Insert DIAM for the target, in MAS.',$
                         '      3. Insert the range of hour angle for the observation',$
                         '      4. Select Telescopes and click "Plot V2" to check the plot', $
                         '      5. Click "Save" to save the UV and Vis2 plot to a file', $ 
                         '      e.g., Target:  HD159561      RA: 17 34 56.0705      Dec: +12 33 36.125  ',$
                         '            HA:  -2  to 2 hrs      Diam:1.7 mas', '' ]
                         
             widget_control, info.b1_text, set_value=help1_text,/append
             end
     'Target' :begin
             info.values.target=event.str
             info.values.target_ind = event.index
             ;print, 'Target:', info.values.target

             if info.values.target_ind ne -1 then begin
                    widget_control, info.ra, set_value=(*info.values.tabinfo).data_ra[info.values.target_ind]
                    widget_control, info.dec, set_value=(*info.values.tabinfo).data_dec[info.values.target_ind]
             endif else begin
 		    widget_control, info.ra, set_value=''
                    widget_control, info.dec, set_value=''
             endelse

             end
     'RA' : begin
             widget_control, info.ra, get_value=ra_str
             info.values.ra_str=ra_str
            ;print, 'RA: ',info.values.ra_str
          end
     'Dec' : begin
             widget_control, info.dec, get_value=dec_str
             info.values.dec_str=dec_str
            ;print, 'Dec: ', info.values.dec_str
           end
     'HA_from': begin
                widget_control, info.ha_from, get_value=ha_from
                info.values.ha_from=ha_from
                ;print, 'HA_from: ', info.values.ha_from
              end
     'HA_to': begin
              widget_control, info.ha_to, get_value=ha_to
              info.values.ha_to=ha_to
              ;print, 'HA_to', info.values.ha_to
            end
     'Diam' : begin
              widget_control, info.diam, get_value=diam
              info.values.diam=diam
              ;print, 'Diam', info.values.diam
            end
     'calV2': begin 
              if event.select eq 1 then begin
              info.values.tab2_nops = 1
              info.values.output_tab2 = ''

              calV2_skip0:
              target = info.values.target

              widget_control, info.ra, get_value=ra_str
              widget_control, info.dec, get_value=dec_str
              info.values.ra_str = ra_str
              info.values.dec_str=dec_str
              ra_str = float(strsplit(info.values.ra_str,/extract))
                if n_elements(ra_str) ne 3 then begin
                   widget_control, info.b1_text, set_value=['Please give a proper R.A.  e.g., 01 23 45.6']
                   goto, skip_calV2
                endif
              dec_str= strsplit(info.values.dec_str,/extract)
                if n_elements(dec_str) ne 3 then begin
                   widget_control, info.b1_text, set_value=['Please give a proper Dec.  e.g., +10 23 45.6'] 
                   goto, skip_calV2
                endif

                factor_str = strmid(dec_str[0],0,1)
                if factor_str eq '-' then factor =-1. else factor = 1.0
              dec_str = float(dec_str)

              ra = ra_str[0]+ ra_str[1]/60. + ra_str[2]/3600.
              dec= factor* (abs(dec_str[0]) + dec_str[1]/60. + dec_str[2]/3600.)
              location=radec_convert(ra, dec)

              ha_from= float(info.values.ha_from)
              ha_to  = float(info.values.ha_to)
              ha_ran = pvector([ha_from, ha_to, 100])
              ha_mean = (ha_from + ha_to)/2. 

              diam = float(info.values.diam)

              tab2_tele = [info.values.tab2_s1, info.values.tab2_s2, info.values.tab2_e1, info.values.tab2_e2, $
                           info.values.tab2_w1, info.values.tab2_w2]

              tab2_tele_ind = where(tab2_tele eq 1)

              widget_control, info.b1_text, /append, set_value= ['-> Calculating Vis2:','   Target: '+info.values.target+' RA: '+info.values.ra_str+$
                         ' Dec: '+ info.values.dec_str+' HA from :'+ info.values.ha_from+ ' to :'+ info.values.ha_to+ ' Diam: '+ info.values.diam, '']

              ;if info.values.tab2_nops eq 0 then widget_control, info.b1_text, /append, set_value= ['-> Output to file :'+info.values.output_tab2]
              chara_telescope_sel2,tele=tab2_tele_ind, baseline_cut=330,sour=target,ra=location.ra,dec=location.dec,/proj, $
                                   ha=ha_mean, hour_range=ha_ran, diam=diam,  nops=info.values.tab2_nops, fname=info.values.output_tab2, $
                                   gui_text_id = info.b1_text, gui_draw_id = info.b1_draw, band=info.values.tab2_band, pinfo=pinfo



              endif
              skip_calV2:
                  ; Add program that calculate V2 here....
              ;print, 'calV2'
            end
      'Tab2_S1':begin
                  if event.select eq 1 then info.values.tab2_s1 = 1 else info.values.tab2_s1 = 0
                
               end
      'Tab2_S2':begin
                  if event.select eq 1 then info.values.tab2_s2 = 1 else info.values.tab2_s2 = 0  
               end
      'Tab2_E1':begin
                  if event.select eq 1 then info.values.tab2_e1 = 1 else info.values.tab2_e1 = 0
               end
      'Tab2_E2':begin
                  if event.select eq 1 then info.values.tab2_e2 = 1 else info.values.tab2_e2 = 0
               end
      'Tab2_W1':begin
                  if event.select eq 1 then info.values.tab2_w1 = 1 else info.values.tab2_w1 = 0
               end
      'Tab2_W2':begin
                  if event.select eq 1 then info.values.tab2_w2 = 1 else info.values.tab2_w2 = 0
               end
      'tab2_band': begin
                  info.values.tab2_band= event.index 
             end
      'save_vis2': begin

              tele=[info.values.tab2_s1, info.values.tab2_s2, info.values.tab2_e1, info.values.tab2_e2, $
                    info.values.tab2_w1, info.values.tab2_w2]
              pops=[info.values.pop_s1, info.values.pop_s2, info.values.pop_e1,info.values.pop_e2,$  ; this is actually not used, so can be any values
                    info.values.pop_w1,info.values.pop_w2]

              mplan_get_Tname, Tname, POPname, Tname2=Tname2, tele=tele, pops=pops

              if info.values.tab2_band eq 0 then bandname='H' else bandname='K'
              output_tab2 = dialog_pickfile(filter='*.ps', file=info.values.target+'_'+tname2+'_'+bandname+'.ps', title='Input the Vis2 plot file name: ')
              info.values.output_tab2 = output_tab2            

              info.values.tab2_nops=0
              goto, calV2_skip0
             end
     'Help2': begin
              help2_text=['Help: 1. Input the path of the target list file, or click "Browse" to select', $
                          '      2. Input observing date', $
                          '      3. Click "Check plot" to see plot on terminal. ', $
                          '         Or, give a PS file name to "Output File" and save the plot to a file.', $
                          '      Targets are plotted in colors: Green: Calibrator, Red: Binary , Blue: Fast rotator ...' ,$                 
                          '      See example_targetlist.txt as an example',$
                          '      -------  Example of target list --------', $
                          ' ',$
'Source        Ra            Dec        Weight   V       H       K   SType    Type   Vsini(km/s)  Diam(mas)   Comments',$
'---------------------------------------------------------------------------------------------------------------------', $
'Altair    19 50 46.9990 +08 52 05.959   1.00   0.77   0.102  0.102  A7V      ROT    Vsini=210    Diam=3.12   rapid rotator',$
'Vega      18 36 56.3364 +38 47 01.291   1.00   0.03   -0.029 0.129  A0V      CAL    Vsini=275    Diam=3.36   rapid rotator',$
'Bet Lyr   18 50 04.7947 +33 21 45.601   1.00   3.367  3.351  3.192  B7Ve     Bin    P=12.9d      Sep=0.23    Binary',$
'']
              widget_control, info.b4_text, /append, set_value=help2_text
              ;print, 'Help2'
            end
     'Input1': begin
                 widget_control, info.input1, get_value=input1
                 info.values.input1=input1
                 ;print, 'Input1', info.values.input1

              end
     'Browse1a': begin
                   input1=dialog_pickfile(filter='*.txt', title='Give the target list filename:')
                   widget_control, info.input1, set_value=input1
   		   info.values.input1=input1
                   ;print, 'Browse1a', info.values.input1

               end
     'Output1': begin 
                 widget_control, info.output1, get_value=output1
		 info.values.output1=output1
                 ;print, 'Output1', info.values.output1
              end
     'Browse1b': begin 
                 output1=dialog_pickfile(filter='*.ps', title='Give the sky plot filename:')
		 info.values.output1=output1
                 widget_control, info.output1, set_value=output1
                 ;print, 'Browse1b', info.values.output1
               end
     'obsmon' : begin
 		 widget_control, info.obsmon, get_value=obsmon
                 info.values.obsmon = obsmon
                 ;print, 'obsmon: ', info.values.obsmon
              end
     'obsday' : begin
                 widget_control, info.obsday, get_value=obsday
                 info.values.obsday = obsday
                 ;print, 'obsday', info.values.obsday
              end
     'obsyear' : begin
                 widget_control, info.obsyr, get_value=obsyr
                 info.values.obsyr = obsyr
                ;print, 'obsyr', info.values.obsyr
             end
     'checkplot1' : begin

                  ; add pro to plot the sky map here ...
                obsyr = fix(info.values.obsyr)
                mon = (fix(info.values.obsmon))[0]
                day = (fix(info.values.obsday))[0]
                help, obsyr, mon, day
                if info.values.input1 eq '' then widget_control, info.b4_text,/append, set_value=['-> Warning: No taget list. Please input the name of the file that contains the target list!!!',''] else begin
			widget_control, info.b4_text, /append, set_value=['Plotting sky map for the target list: Obs. Date = '+info.values.obsyr+'-'+info.values.obsmon+'-'+info.values.obsday, '']
			obj_pos_mplan, day=day, month=mon, year=obsyr, file=info.values.input1 
		  
		endelse                

                ;print, 'checkplot1: ' 
                  end
     'Save1' : begin
                obsyr = fix(info.values.obsyr)
                mon = (fix(info.values.obsmon))[0]
                day = (fix(info.values.obsday))[0]

		if info.values.input1 eq '' then widget_control, info.b4_text,/append, set_value=['-> Warning: No taget list. Please input the name of the file that contains the target list!!!',''] else begin
                  if (info.values.output1 eq '') then begin
                    widget_control, info.b4_text,/append, set_value=['-> Warning: No OUTPUT file name. Using default: '$
                          +'Target_skymap_'+info.values.obsyr+'_'+info.values.obsmon+'_'+info.values.obsday+'.ps', '']
                          info.values.output1 = 'Target_skymap_'+info.values.obsyr+'_'+info.values.obsmon+'_'+info.values.obsday+'.ps'
                    widget_control, info.output1, set_value=info.values.output1
                  endif 
		   widget_control, info.b4_text, /append, set_value=['Saving the sky map for the target list to file: '+info.values.output1,$
                                                         ' Obs. Date = '+info.values.obsyr+'-'+info.values.obsmon+'-'+info.values.obsday, '']
                        obj_pos_mplan, day=day, month=mon, year=obsyr, outfile=info.values.output1, file=info.values.input1,/dops
                
                endelse

                ;print, 'Save1'
             end
     'Help3' : begin
		help3_text=['Help: 1. Select four telescopes out of six',$
                            '      2. (Optional)',$
                            '         If want to check the sky coverage for certain POPs, set POP numbers',$
                            '         for the chosen telescopes and click "Check POP plot", or save the plot to a PS file',$
                            '         Default is to save the ps file to directory: POPcoveragePlot/',$
                            '      3. (Optional)',$
                            '         "Fix POP" is used for optimization when one wants to fix one or several of the POPs while',$
                            '         searching for other POP configs.  e.g., Fix POP = 1,   2  for S1  E1 means S1 POP is fixed',$
                            '         to 1 and E1 POP is fixed to 2', '']
		widget_control, info.b4_text, /append, set_value=help3_text
                ;print, 'Help3'
             end
     'S1': begin
              if event.select eq 1 then begin 
                  info.values.s1=1
                  widget_control, info.pop_s1, /sensitive
              endif else begin
                  info.values.s1=0
                  widget_control, info.pop_s1, sensitive=0,set_value=''
              endelse
              ;print, 'S1'
         end
     'S2': begin
              if event.select eq 1 then begin 
                  info.values.s2=1
                  widget_control, info.pop_s2, /sensitive
              endif else begin
                  info.values.s2=0
                  widget_control, info.pop_s2, sensitive=0, set_value=''
              endelse

             ;print, 'S2'
         end
     'E1': begin
              if event.select eq 1 then begin
                  info.values.e1=1
                  widget_control, info.pop_e1, /sensitive
              endif else begin
                  info.values.e1=0
                  widget_control, info.pop_e1, sensitive=0, set_value=''
              endelse

            ;print, 'E1'
         end
     'E2': begin
              if event.select eq 1 then begin
                  info.values.e2=1
                  widget_control, info.pop_e2, /sensitive
              endif else begin
                  info.values.e2=0
                  widget_control, info.pop_e2, sensitive=0, set_value=''
              endelse

            ;print, 'E2'
         end
     'W1': begin
              if event.select eq 1 then begin
                  info.values.w1=1
                  widget_control, info.pop_w1, /sensitive
              endif else begin
                  info.values.w1=0
                  widget_control, info.pop_w1, sensitive=0, set_value=''
              endelse

            ;print, 'W1'
         end
     'W2': begin
              if event.select eq 1 then begin
                  info.values.w2=1
                  widget_control, info.pop_w2, /sensitive
              endif else begin
                  info.values.w2=0
                  widget_control, info.pop_w2, sensitive=0, set_value=''
              endelse

           ;print, 'W2'
         end
     'POP_S1': begin
                widget_control, info.pop_s1, get_value=pop_s1
                info.values.pop_s1=pop_s1
                ;print, 'POP_S1', info.values.pop_s1 
             end
     'POP_S2': begin
                widget_control, info.pop_s2, get_value=pop_s2
                info.values.pop_s2=pop_s2
               ;print, 'POP_S2', info.values.pop_s2
         end
     'POP_E1': begin
                widget_control, info.pop_e1, get_value=pop_e1
                info.values.pop_e1=pop_e1
               ;print, 'POP_E1', info.values.pop_e1
         end
     'POP_E2': begin
                widget_control, info.pop_e2, get_value=pop_e2
                info.values.pop_e2=pop_e2
              ;print, 'POP_E2', info.values.pop_e2
         end
     'POP_W1': begin
                widget_control, info.pop_w1, get_value=pop_w1
                info.values.pop_w1=pop_w1
             ;print, 'POP_W1', info.values.pop_w1
         end
     'POP_W2': begin
                widget_control, info.pop_w2, get_value=pop_w2
                info.values.pop_w2=pop_w2
            ;print, 'POP_W2', info.values.pop_w2
         end
     'FixS1': begin
                if event.select eq 1 then info.values.fixpop_s1 = 1 else info.values.fixpop_s1 = 0
         end
     'FixS2': begin
		if event.select eq 1 then info.values.fixpop_s2 = 1 else info.values.fixpop_s2 = 0
         end
     'FixE1': begin
		if event.select eq 1 then info.values.fixpop_e1 = 1  else info.values.fixpop_e1 = 0
         end
     'FixE2': begin
		if event.select eq 1 then info.values.fixpop_e2 = 1 else info.values.fixpop_e2 = 0
         end
     'FixW1': begin
		if event.select eq 1 then info.values.fixpop_w1 = 1 else info.values.fixpop_w1 = 0
         end
     'FixW2': begin
		if event.select eq 1 then info.values.fixpop_w2 = 1 else info.values.fixpop_w2 =0 
         end
     'Plot2': begin

              tele=[info.values.s1, info.values.s2, info.values.e1, info.values.e2, $
                    info.values.w1, info.values.w2]
              pops=[info.values.pop_s1, info.values.pop_s2, info.values.pop_e1,info.values.pop_e2,$
                    info.values.pop_w1,info.values.pop_w2]

              if (total(tele) eq 0) or (total(pops) eq 0) then widget_control, info.b4_text, /append,$
                 set_value=['No Telescopes and/or POPs are asigned!',''] else begin
              mplan_get_Tname, Tname, POPname, tele=tele, pops=pops 
              info.values.Tname=Tname
              info.values.popname=popname

              widget_control, info.b4_text, /append,set_value=['Plotting pop sky coverage for Tele: '+Tname+'  POP: '+popname, '']
              ; PRO to plot POP coverage here

              tele_id = where(tele eq 1)
              plot_poprange2, tele=tele_id, pop=pops[tele_id],gui_id=info.b4_text

              endelse
            ;print, 'Plot2'
         end
     'Save2': begin

            tele=[info.values.s1, info.values.s2, info.values.e1, info.values.e2, $
                    info.values.w1, info.values.w2]
              pops=[info.values.pop_s1, info.values.pop_s2, info.values.pop_e1,info.values.pop_e2,$
                    info.values.pop_w1,info.values.pop_w2]

            if (total(tele) eq 0) or (total(pops) eq 0) then widget_control, info.b4_text, /append,$
                 set_value=['No Telescopes and/or POPs are asigned!',''] else begin

                tele=[info.values.s1, info.values.s2, info.values.e1, info.values.e2, $
                    info.values.w1, info.values.w2]
                pops=[info.values.pop_s1, info.values.pop_s2, info.values.pop_e1,info.values.pop_e2,$
                    info.values.pop_w1,info.values.pop_w2]
                mplan_get_Tname, Tname2=Tname2, Popname2=Popname2, tele=tele, pops=pops

            	outfile2_default= 'POPcoveragePlot/coverage_T'+tname2+'_P'+popname2 +'.ps'

            	outfile2 = dialog_pickfile(filter='*.txt', file=outfile2_default, title='Input the POP sky coverage plot file (or use default)')
            	info.values.outfile2=outfile2
      
            	widget_control, info.b4_text, set_value=['Saving pop coverage plot to: '+info.values.outfile2, 'Tele: '$
                                                     +info.values.Tname+'  POP: '+info.values.popname, ''],/append
             	; add PRO to save plot

             	tele_id = where(tele eq 1)
             	plot_poprange2, tele=tele_id, pop=pops[tele_id],/dops, filename=outfile2, gui_id=info.b4_text


            endelse
            ;print, 'Save2'
         end
     'Help4': begin
            help4 = ['Help: 1. Choose the optimization method. Default is 2, and is most used',$ 
                     '      2. Set sorting method. Default is 2 ',$
                     '      3. Give output file name (.txt), or browse to select',$
                     '           Use DEFAULT if no outfile is given',$
                     '      4. Set/change target priorities. Or set/change priorities directly in the target list file',$
                     '      5. Set other parameters',$
                     '      6. Give an output file name. Use default if no file is given', $
                     '      7. Optimize for the given target list and observing date inserted previously in tool box 1.',$
                      '' ]
            widget_control, info.b4_text, set_value=help4,/append
            ;print, 'Help4'
         end
     'optmethod': begin
            info.values.optmethod = event.index
            b3_text=['Optimize total observable time', 'Optimize observable time for high priority targets']
            widget_control, info.b3_text, set_value=b3_text[info.values.optmethod]
            ;print, 'optmethod', info.values.optmethod
         end
     'sortmethod': begin
                   info.values.sort = event.index
                   sort_text=['Sort targets by their observable duration', 'Sort targets by their observation start & end time']
                   widget_control, info.sort_text, set_value=sort_text[info.values.sort]

         end
     'priority': begin
            if info.values.input1 eq '' then widget_control, info.b4_text, /append, $
               set_value=['Warning: No target list exist. Please input the target list file name in the upper left toolbox!',''] else begin
            widget_control, info.b4_text, /append, set_value=['Setting priorities for the targets...', $
                         'Please scale your priorities such that most targets have weights= 1 (default) ',$
                         'and a few most important ones have weight= 5 ! ','']
            ; POP up a window and choose for target priorities.
            set_priority_mplan, file=info.values.input1, leader=event.top

            endelse
	    ;print, 'priority' 
         end
     'n_output': begin
		 widget_control, info.n_output, get_value=n_output
                 info.values.n_output = fix(n_output)
         end
     'starttime': begin
                 widget_control, info.starttime, get_value=starttime
                 info.values.starttime = float(starttime)
         end 
     'endtime': begin
                widget_control, info.endtime, get_value=endtime
                info.values.endtime = float(endtime)
         end
     'timeshreshold': begin
                widget_control, info.timeshreshold, get_value=timeshreshold
                info.values.timeshreshold = float(timeshreshold)
         end
     'Optimize': begin
            if info.values.input1 eq '' then begin
               widget_control, info.b4_text, /append, $
               set_value=['Warning: No target list exist. Please input the target list file name in the upper left toolbox!','']
               goto, skip_optimize
            endif 


            widget_control, info.b4_text, /append, set_value=['Optimizing observation schedule ...']
            optmize_output = info.values.outfile3

              tele=[info.values.s1, info.values.s2, info.values.e1, info.values.e2, $
                    info.values.w1, info.values.w2]
              pops=[info.values.pop_s1, info.values.pop_s2, info.values.pop_e1,info.values.pop_e2,$
                    info.values.pop_w1,info.values.pop_w2]

              if (total(tele) ne 0) then begin

                 if (optmize_output eq '') or (optmize_output eq '(Use default)') then begin
                   mplan_get_Tname, Tname2=Tname2, tele=tele, pops=pops

                   optmize_output = 'MircPlan_'+Tname2+'_'+info.values.obsyr+'_'+ $
                                 info.values.obsmon+'_'+info.values.obsday+'.txt'

                    widget_control, info.b4_text, /append, set_value=['Output to : '+optmize_output,'']
                 endif else widget_control, info.b4_text, /append, set_value=['Output to : '+optmize_output,'']

              endif else begin
                    widget_control, info.b4_text, /append, set_value=['Please assign telescopes first',''] 
                    goto, skip_optimize
                    endelse


            tele_ind = where(tele eq 1, cnt)
            if cnt eq 0 then goto, skip_optimize 

            if info.values.n_output eq 0 then begin
               info.values.n_output = 3 
               widget_control, info.b4_text, /append, set_value=['# of output blocks: using default -> 5']
            endif


            fixpop = [info.values.fixpop_s1, info.values.fixpop_s2, info.values.fixpop_e1, info.values.fixpop_e2, $
                         info.values.fixpop_w1, info.values.fixpop_w2]
            fixed_pop = [0,0,0,0,0,0]
            fix_ind = where(fixpop  eq 1, cnt)
            ; PRO to optimize

            if cnt ge 1 then begin

                fixed_pop[fix_ind] = pops[fix_ind]
                fixed_pop_id = fixed_pop[tele_ind]   ; to make the index compatible with chara_obs_plan2

                fixed_pop_id_name=''
                for lp=0, n_elements(fixed_pop_id)-1 do fixed_pop_id_name+=string(fixed_pop_id[lp])+' '

                widget_control, info.b4_text,/append,set_value=['Some POPs are fixed in the optimization: '+string(fixed_pop_id_name),'']
                chara_obs_plan3, tele=tele_ind, src_filename=info.values.input1, outputid=optmize_output, $
                                opti=info.values.optmethod+1,  obst=info.values.timeshreshold, $
                                sorting =info.values.sort+1, starttime=info.values.starttime, endtime=info.values.endtime, $
                                npop=info.values.n_output, date=fix(info.values.obsday), mon=(fix(info.values.obsmon))[0], $
                                year=fix(info.values.obsyr), popfix=fixed_pop_id, gui_id=info.b4_text
            endif else begin
                chara_obs_plan3, tele=tele_ind, src_filename=info.values.input1, outputid=optmize_output, $
                                opti=info.values.optmethod+1, obst=info.values.timeshreshold, $
                                sorting =info.values.sort+1, starttime=info.values.starttime, endtime=info.values.endtime, $
                                npop=info.values.n_output, date=fix(info.values.obsday), mon=(fix(info.values.obsmon))[0], $
                                year=fix(info.values.obsyr), gui_id=info.b4_text

            endelse


            skip_optimize:

         end
     'Output3': begin
                widget_control, info.output3, get_value=output3
                info.values.outfile3=output3
                ;print, 'Output3: ', info.values.outfile3
                end
     'Browse3': begin
                info.values.outfile3 = dialog_pickfile(filter='*.txt', title='Given the output filename for optimization results:')
                widget_control, info.output3, set_value=info.values.outfile3
                ;print, 'Browse3: ', info.values.outfile3  
                end
     'ID':      begin
                    ;if target id list already exists then skip
                    ;else get ids
   
                   widget_control, info.b4_text,/append,set_value=['Querying SIMBAD for target ID (HR or HD or IRC) ...' ,'']

                    if info.values.input1 ne '' then begin
                         pop_info = info.values.input1

                      if file_search(info.values.input1+'.id.idl') ne '' then begin
                         ;pop up a window
;                          cnfrm = ptr_new(0)
                          mplan_popup, 'Target ID list already exists. Do you have to overwrite? This may take a long time', pop_info                          
;                          if *cnfrm eq 1 then begin
;                             overwrite:
;                             restore, 'read_src_temp1.idl'
;                             data = read_ascii(info.values.input1, template=temp1)
;                             target_name = data.name
;
;                             ; get src names and then get ids
;                              target_id = get_src_name(target_name)
;                              save, target_name, target_id, filename=info.values.input1+'.id.idl'
;                          endif
;                         ptr_free, cnfrm
                      endif else begin 
;                          cnfrm = ptr_new(0)
                          mplan_popup, 'Making a target ID (HR, HD, IRC) list. This may take a long time. Are you sure to continue?', pop_info
;                          if  *cnfrm eq 1 then goto, overwrite
                      endelse  


                   endif else widget_control, info.b4_text,/append,set_value=['Please input the filename for the target list first! ' ,''] 
                end


Endcase

(*pinfo).values = info.values


END


