
Function read_src_chara_plan3, fname=fname

; To read data files use for MIRC observation planning.
; NOTE: Note the FACTOR used to show the sign in Dec.!!!
; Used by obs_plan.pro
;
; Ming Zhao, last modified, 05/21/06

restore, 'poprange/source_template_chara_V0.4.idl' 


 data = read_ascii(fname, template=temp)

src_ra  = (data.field02 + data.field03/60. + data.field04/3600.)   ; in Hours


factor_str = strmid(data.field05, 0,1)
factor_ind= where(factor_str eq '-', indcnt)

factor = make_array(n_elements(src_ra), value=1.0)
if indcnt ge 1 then factor[factor_ind]=-1. 

field05 = float(data.field05)

src_dec = (field05 + factor*data.field06 / 60. + factor*data.field07 / 3600.)       ; in Degree
src     = dblarr(2, n_elements(src_ra))
src[0,*] = src_ra
src[1,*] = src_dec

source = data.field01
weight=data.field08
Vmag = data.field09
Hmag = data.field10
Kmag= data.field11

spec_type  =  data.field12
type =  data.field13
comments=data.field14


data={pos:src, weight:weight, vmag:vmag, hmag:hmag, kmag:kmag, name:source, type:type, spec_type:spec_type, comm:comments }

return, data

end
