

; PRo to set the priorities for targets

PRO set_priority_cleanup, id

widget_control, id, get_uvalue=info
fname= (*info).fname
len = strlen(fname)
fname2=strmid(fname, 0,len-4)+'.mplan.txt'

; check whether the weights have been changed

new_wei = (*info).values.weight
old_wei = (*info).values.old_weight

ind = where( (new_wei eq old_wei) eq 0, cnt)

if cnt ge 1 then begin

	restore, 'pros/read_src_temp1.idl'
	data = read_ascii(fname, template=temp1)

	openw, lun, fname2, /get_lun
	openr, lun2, fname, /get_lun

	tmp=''

	for lp=0,1 do begin
		readf, lun2, tmp
		printf, lun, tmp
	endfor

	n_names = n_elements(data.name)
	weight = (*info).values.weight

	for lp2=0, n_names-1 do $
		printf, lun, (data.name)[lp2], (data.ra_dec)[lp2], weight[lp2], (data.comment)[lp2], $
                        format='(A8,2x, A27, 3x, f4.2, 3x, A)'

	free_lun, lun,lun2
	close,/all

        test = FILE_SEARCH(fname+'.backup')
        if test eq '' then spawn, 'mv '+fname+' '+fname+'.backup'
        spawn, 'mv -f '+fname2+' '+fname
endif 

ptr_free, info
print, 'set_priority widget closed.'



END

;---------------------------------------------------

PRO set_priority_event, event

tar_name= widget_info(event.id,/uname)

widget_control, event.top, get_uvalue=info

weight= widget_info(event.id, /droplist_select)   ; get the index of the weight, the actual weight need +1

id = where((*info).values.target eq tar_name, cnt)
if cnt ge 1 then begin
   (*info).values.weight[id] = weight+1
endif else print, '--> Warning: No matching target names !!!'

END



;---------------------------------------------------

PRO set_priority_mplan, file=fname, output_widget_id=out_id, leader= leader


 ; Load data 
restore, 'pros/read_src_temp1.idl'
data=read_ascii(fname, template=temp1)
names = data.name

n_rows = n_elements(names)

 ; Make widget

top= widget_base(tit='Target Priority', col=1, scr_xsize=240, frame=1,/scroll,scr_ysize=400 , /base_align_left, group_leader=leader)
lines = lonarr(n_rows)
targets=lonarr(n_rows)
drops = lonarr(n_rows)
drop_values= ['1    ','2    ','3    ','4    ','5    ']
drop_uval = fix(data.weight)-1   ; set the index of the weights

tit = widget_base(top, /base_align_center, row=2, frame=2)
tit_lab1 = widget_label(tit, value='       Set Target Priority    ')
tit_lab1 = widget_label(tit, value='        1=default   5=high   ')

tar =  widget_base(top, /base_align_right, col=1)

for lp=0, n_rows-1 do begin
      
          drops[lp] = widget_droplist(tar,  GROUP_LEADER=top, tit=names[lp], value=drop_values,/dynamic_resize, uvalue=drop_uval[lp], uname=names[lp])
          widget_control, drops[lp], SET_DROPLIST_SELECT=drop_uval[lp]

endfor

values = {target:names, weight:drop_uval+1, old_weight:drop_uval+1}

info_struc = {drop:drops, values:values, fname:fname}
info = ptr_new(info_struc, /no_copy)

widget_control, top, /realize
widget_control, top, set_uvalue=info

xmanager, 'set_priority', top, cleanup='set_priority_cleanup'

end

