; 20001Feb03
; JDM
; used by fringe_power.ps
; 2006Oct24 JDM	Added /linear for chara mirc analysis

pro analyze_fringe_ps, bg1=bg1, bg2=bg2, sig=sig, ps=ps,  hertz=hertz, $inputs
    mask = ps_mask, $
    background=background,v2=v2, $
    gauss=gauss, gterms=gauss_terms, gfit=gaussfit_results,$
    status=status,interp_ps = interp_ps,$
    linear=linear ; outputs,

;if /linear then fit line.

status = 1
if (n_elements(ps_mask) eq 0) then begin
  ps_mask=ps
  ps_mask(*)=1  ; all good
endif 



; OK -- The way the ps_mask works is that it interpolates OVER the bad areas
; before doing the fitting and adding up the power.
; However, to make it less sensitive to noise, the interpolation is based on
; smoothed version of the powspec (by 10 pixels)

interp_ps = ps
smooth_ps = ps*ps_mask
smooth_ps = smooth(smooth_ps,8,/edge)/smooth(ps_mask,8,/edge)

in_bad = where(ps_mask eq 0,ct)
if (ct gt 0 ) then begin
 in_good = where(ps_mask eq 1)
 hh=hertz(in_good)
 pp=smooth_ps(in_good)
 in_sort = sort(hh)
 result = interpol( pp(in_sort),hh(in_sort),hertz(in_bad) )
 interp_ps(in_bad) = result
endif 




delta_hertz=hertz(1)-hertz(0)

in1=where(hertz ge min(bg1) and hertz le max(bg1) and ps_mask eq 1,ct1)
if (ct1 eq 0) then in1=0

in2=where(hertz ge min(bg2) and hertz le max(bg2) and ps_mask eq 1,ct2)
if (ct2 eq 0) then in2=where(hertz eq max(hertz))

in=where(hertz ge min(sig) and hertz le max(sig) and ps_mask eq 1,ct)

if (ct eq 0) then in=nint(.5*(in1+in2))
in_interp = where( hertz ge min(sig) and hertz le max(sig),ct)
if (ct eq 0) then in_interp=nint(.5*(in1+in2))

if ( ct1 le 1 or ct2 le 1 or ct le 1) then begin
  print,'No fitting done. Must have at least two points for bg1, bg2, sig'
  v2=0
  background=replicate(0.0,n_elements(ps))
  status = -1
  goto,skiptoend
endif

ps1=mean(ps(in1))
ps2=mean(ps(in2))
x1=mean(hertz(in1))
x2=mean(hertz(in2))


;Special case if ps1 or ps2 is NEGATIVE!!!!
if (ps1 gt 0 and ps2 gt 0) then begin
logbackground=(alog10(ps2)-alog10(ps1))*(hertz-x1)/(x2-x1)+alog10(ps1)
background=10.0^(logbackground)
endif else begin ; if NEGATIVE do linear fit not exponential
  background = (ps2-ps1)*(hertz-x1)/(x2-x1) + ps1
endelse

if keyword_set(linear) then begin
  in_bg=[in1,in2]
  coef=robust_linefit(hertz(in_bg),ps(in_bg) )
  background=coef(0)+hertz*coef(1)
endif


v2a=total( (ps-background)(in))*delta_hertz
v2=total( (interp_ps-background)(in_interp))*delta_hertz
;print,v2,v2a
;stop

if (keyword_set(gauss) eq 1) then begin

ins=[in1,in,in2]
in_bg=[in1,in2]

; Use background level from above... [background]
goto,skipthese
; Fit quadratic to background 
;result=poly_fit(hertz(in_bg),ps(in_bg),2)
;result=reform(result)

; Fit Line to background
result =poly_fit(hertz(in_bg),ps(in_bg),1)
result =[reform(result),0]


bg_fit=result(0)+result(1)*hertz+result(2)*hertz*hertz

skipthese:
bg_fit=background

; Subtract background from, then fit gauss to center portion only
xx=hertz(in)
yy=(ps-bg_fit)(in)

estimates = [max(yy),xx(where(yy eq max(yy))),n_elements(where( yy gt max(yy)*.36))/2.*delta_hertz]

fit=gaussfit(hertz(in),(ps-bg_fit)(in),nterm=3,terms,estimates=estimates)
;stop
gauss_terms=[terms];    ,result]

z=(hertz-gauss_terms(1))/gauss_terms(2)
gaussfit_results=gauss_terms(0)*exp(-z^2/2.)+background;

;+gauss_terms(3)+$

;    gauss_terms(4)*hertz+gauss_terms(5)*hertz^2
endif

;stop

skiptoend:

end

