; 2006Dec14 JDM

; takes complex array representing real/imaginary parts of phasor.
; will do averaging and return the msn and errors for
; rp,ip  as well as amp,phase(degs)

PRO BOOT_MEAN_complex_dim, array, rp_means, rp_sigmas, ip_means,ip_sigmas,$
  amp_means,amp_sigmas,phase_means,phase_sigmas,dim=dim,num=num

; dim= what dimension to do bootstrap.  should be fast for multi-dim data.
 ;     1,2,3,4,... (does not start at 0)
; MAX 8

; default is to bootstrap along the last dimension

if keyword_set(num) eq 0 then num=50

info=size(array,/dim)
ndim=n_elements(info)
if keyword_set(dim) eq 0 then dim=ndim
n=info(dim-1)

; shuffle the bootable dimension to front
tvector=indgen(ndim)
tvector(0)=dim-1
tvector(dim-1)=0

newarray=array
if dim ne 1 then begin ; don't reorder if first.
 newarray=transpose(array,tvector)
endif
newinfo=size(newarray,/dim)
temp=newarray(0,*,*,*,*,*,*,*)  
newinfo(0)=num
newinfo0=newinfo
newinfo0(0)=1
rp_meansb=rebin(float(temp),newinfo)
ip_meansb=rebin(imaginary(temp),newinfo)
meansb=complex(rp_meansb,ip_meansb)

FOR L=0,Num-1 DO BEGIN
; Uniform random numbers between 0 and N-1:
  PICK=RANDOMU(seed,N)
  R=FIX(PICK*N)
  meansb(l,*,*,*,*,*,*,*) = total(  newarray(r,*,*,*,*,*,*,*) ,1)/n
endfor

rp_means =  total(     float(meansb)     ,1)/num
ip_means =  total( imaginary(meansb)     ,1)/num
amp_means=  total(       abs(meansb)     ,1)/num
; Can't ust average phases directly in boot but
; must first subtract the mean.
phase_means=atan(ip_means,rp_means,/phase)*180/!pi

; now do sigma in parallel form.
means_plus = rebin(reform([rp_means],newinfo0),newinfo)
diff_plus=(float(meansb)-means_plus)^2
rp_sigmas= sqrt(total(diff_plus,1)/num)

means_plus = rebin(reform([ip_means],newinfo0),newinfo)
diff_plus=(imaginary(meansb)-means_plus)^2
ip_sigmas= sqrt(total(diff_plus,1)/num)

means_plus = rebin(reform([amp_means],newinfo0),newinfo)
diff_plus=(abs(meansb)-means_plus)^2
amp_sigmas= sqrt(total(diff_plus,1)/num)

means_plus = rebin(reform([phase_means],newinfo0),newinfo)
diff_plus=(mod360(atan(meansb,/phase)*180./!pi -means_plus))^2
phase_sigmas= sqrt(total(diff_plus,1)/num)






if dim ne 1 then begin
 rp_means=reform(    transpose(  reform(rp_means,newinfo0),tvector))
 rp_sigmas=reform(   transpose(  reform(rp_sigmas,newinfo0),tvector))
 ip_means=reform(    transpose(  reform(ip_means,newinfo0),tvector))
 ip_sigmas=reform(   transpose(  reform(ip_sigmas,newinfo0),tvector))
 amp_means=reform(    transpose(  reform(amp_means,newinfo0),tvector))
 amp_sigmas=reform(   transpose(  reform(amp_sigmas,newinfo0),tvector))
 phase_means=reform(    transpose(  reform(phase_means,newinfo0),tvector))
 phase_sigmas=reform(   transpose(  reform(phase_sigmas,newinfo0),tvector))

endif 


RETURN
END
