; 2006Dec17 JDM	Mod of boot_ratio_wt.pro for t3amp (phasor averaging)

function boot_ratio_t3amp_wt,x,y,phase, weight,num_samples=num_samples,result=result
; returns the boot results.
; result = [resistant mean, robust_sigma]

;  This will pass Bootstrapped samples of phasor(x),y to
; mean normalized amp and return the result.

; x,phase is the phasor with phase in degrees


; The function will return a vector of NUM_SAMPLES 
; with each realization of the bootstrap.


if (keyword_set(num_samples) eq 0) then num_samples=100
x0=reform(x)
y0=reform(y)
phase0=reform(phase)
x_num=(size(x0))(1)

answer=fltarr(num_samples)
for i=0,num_samples-1 do begin
  index=x_num*randomu(seed,x_num)
;  print,i,',',index
;  answer(i)=mean_ratio(x(index),y(index))
   t3 = complex(x0*cos(phase0*!pi/180.), x0*sin(phase0*!pi/180.))
   answer(i)= abs(  total( weight(index)*t3(index)) / total( y(index)*weight(index)) )
endfor

result=[robust_mean(answer,sig=sig),sig]

return,answer
end

