;2004Jul16 JDM
;2005May29 JDM  added errors

function caltables, times_out,  times, val, val_err , smoothlength,$
   phase=phase,booterror=booterror,nsamps=nsamps
; if /phase then val/val_err is in degrees
; booterror works by doubling the smoothlength and then calculating the rror via bootstrap+MonteCarlo
; [the monte carlo part takes care of the issue of calibrator sizes at least in a rough way.
; do not trust this procedure for detailed work since this neglects correlations between error bars.

if keyword_set(nsamps) eq 0 then nsamps=50

if (keyword_set(phase) eq 0) then begin

cvals=fltarr(n_elements(times_out))
for ss=0,n_elements(times_out)-1 do begin

wts = exp(-1.*(times-times_out(ss))^2/(smoothlength)^2)/$
     ( (val_err/val)>.05)^2

 ; weight based on signal to noise, but don't give added advantag efor
 ; <5% percent error.

 cvals(ss) = total(wts*val)/total(wts)
endfor
endif else begin ; PHASE

cvals=fltarr(n_elements(times_out))
for ss=0,n_elements(times_out)-1 do begin

wts = exp(-1.*(times-times_out(ss))^2/(smoothlength)^2)/$
     ( (val_err)>.5)^2

 ; weight based on angle error but don't give added advantag efor
 ; <0.5 degree error.

 cprp=total(wts*cos(val*!pi/180.))
 cpip=total(wts*sin(val*!pi/180.))
 cvals(ss) = mod360(atan(cpip,cprp)*180/!pi)
endfor

endelse

;-------------------------------
; NOW do bootstrap
booterror=cvals

results=fltarr(nsamps,n_elements(cvals))
  nvals=n_elements(val)

for i=0,nsamps-1 do begin
  val0=val+val_err*randomn(seed,nvals)
  inb=fix(nvals*randomu(seed,nvals) )

btimes=times(inb)
bval_err=val_err(inb)
bval=val0(inb)

cvals0=fltarr(n_elements(times_out))


if (keyword_set(phase) eq 0) then begin

for ss=0,n_elements(times_out)-1 do begin

wts = exp(-1.*(btimes-times_out(ss))^2/(smoothlength)^2)/$
     ( (bval_err/bval)>.05)^2

 ; weight based on signal to noise, but don't give added advantag efor
 ; <5% percent error.

 cvals0(ss) = total(wts*bval)/total(wts) - cvals(ss)
endfor
endif else begin ; PHASE

for ss=0,n_elements(times_out)-1 do begin

wts = exp(-1.*(btimes-times_out(ss))^2/(smoothlength)^2)/$
     ( (bval_err)>.5)^2

 ; weight based on angle error but don't give added advantag efor
 ; <0.5 degree error.

 cprp=total(wts*cos(bval*!pi/180.))
 cpip=total(wts*sin(bval*!pi/180.))
 cvals0(ss) = mod360((atan(cpip,cprp)*180/!pi)-cvals(ss))
endfor

endelse
results(i,*)=cvals0
endfor

; alc error
for i=0,n_elements(times_out)-1 do begin
  booterror(i)=stdev(results(*,i))
endfor


;----------------




return,cvals
end

