function diffdata,data,sigma=sigma,nodiff=nodiff

; /nodiff -- this is a nonsense flag unless /sigma flag.
; when both /sigma and /nodiff are set then this routine
; will do differences and look for outliers (most robust way to do this).
; then it will RE-pack as an accumulation array. This will fix big voltage
; offsets and generally clean up digital problems (like we say in 2006Aug
; data set after hurried re-install of mirkwood RT OS)

; take differences and make last point the same as 2nd last so the
; array size doesn't change.


info=size(data,/dim)
; Assmume data is 3-d. (x,y,frames)
xdim=info(0)
ydim=info(1)
zdim=info(2)

ndim=3
data0=data

; The following commented out code is slow and obsolete now.
;for i=0,info(ndim-1)-3 do begin
;data0(*,*,i)=data(*,*,i+1)-data(*,*,i)
;endfor
;data0(*,*,i)=data0(*,*,i-1)
;data0(*,*,i+1)=data0(*,*,i-1)

data0=shift(data,0,0,-1)-data
data0(*,*,zdim-2)=data0(*,*,zdim-3)
data0(*,*,zdim-1)=data0(*,*,zdim-3)


if (keyword_set(sigma) eq 1) then begin

; Do a sigma filter.
nch=0
nsig=10.
nmed=5
for i=0,xdim-1 do begin
 for j=0,ydim-1 do begin
  y=reform(data0(i,j,*))
  medy=medsmooth(y,nmed)
  diff=y-medy
 ;FAST ROBUST RMS
  diffo=diff(sort(diff))
  rms=stdev(diffo( (.1*zdim):(.9*zdim)))
  in=where( (abs(diff) gt (nsig*rms)),ct)
  nch=nch+ct
  ;if (i eq 40 and j eq 4) then stop
  if ct gt 0 then y(in)=medy(in)
  data0(i,j,*)=y
endfor
endfor
print,'Number of Pixels Changed: ',nch,' out of ',n_elements(data0)
endif

if (keyword_set(nodiff) eq 1) then begin

data1=data0
data0(*,*,0)=data(*,*,0)

for i=1,info(ndim-1)-1 do begin
 data0(*,*,i)=data0(*,*,i-1)+data1(*,*,i-1)
endfor

endif  

return,data0
end


