; 2007Jul    JDM Original
; 2007Aug20  JDM Fixed up....
;		 made compatible between little/big endiens....
;		 [assume written by intel..]

function loadmircdaq,file, old=old, plotit=plotit

; set for Date, volts1, digital4.

; # seconds since Jan 1, 1970		4 bytes
; # of nanoseconds in day		4 bytes
; Float (volts)	Chan 0			4 bytes
; digital (4 channels)			4 vytes

datastruct={seconds:long(1),nanoseconds:long(1),volt0:float(1.0),dummy0:byte(0),dummy1:byte(1),$
        dummy2:byte(2), dummy3:byte(3) }
nbytes=4+4+4+4

if keyword_set(old) eq 1 then begin
 datastruct={seconds:long(1),volt0:float(1.0),dummy0:byte(0),dummy1:byte(1),$
        dummy2:byte(2), dummy3:byte(3) }
 nbytes=4+4+4
endif

dataout_struct={seconds:long(1),nanoseconds:long(1),$
     volt0:float(1.0),din0:fix(0),din1:fix(1),$
               din2:fix(2),din3:fix(3) }


openr,unit,file,/get

info=fstat(unit)
sz=(info.size-4)/nbytes
if sz eq 0 then return,-1
data=replicate(datastruct,sz)
dataout=replicate(dataout_struct,sz)

tempfloat=fltarr(sz)
;templong=ulong(lonarr(sz))
;stop

sz1=long(0)
readu,unit,sz1
readu,unit,data
close,unit
free_lun,unit
;stop
bits=intarr(8,sz)
for n=0l,sz-1l do begin
  temp=data(n).dummy2
for i=7,0,-1 do begin
  val=2^i
  
if temp ge val then begin
  bits(i,n)=1
  temp=temp-val
endif
endfor
endfor

din0=reform(bits(0,*))
din1=reform(bits(1,*))
din2=reform(bits(2,*))
din3=reform(bits(3,*))


if keyword_set(plotit) then begin


deriv0=(din0-shift(din0,-1))(0:(sz-5))
deriv1=(din1-shift(din1,-1))(0:(sz-5))
deriv2=(din2-shift(din2,-1))(0:(sz-5))
deriv3=(din3-shift(din3,-1))(0:(sz-5))
in0=float(where(deriv0 gt .5))
in1=float(where(deriv1 gt .5))
in2=float(where(deriv2 gt .5))
in3=float(where(deriv3 gt .5))

rate0=deriv(in0)
rate1=deriv(in1)
rate2=deriv(in2)
rate3=deriv(in3)

!p.multi=[0,1,4]
yr=mean(rate0)*[.95,1.05]
plot,smooth(rate0,10,/edge),yr=yr,yst=1
oplot,[0,1e6],[yr(0),yr(0)],line=2
oplot,[0,1e6],[yr(1),yr(1)],line=2
oplot,[0,1e6],[mean(rate0),mean(rate0)]
yr=mean(rate1)*[.95,1.05]
plot,smooth(rate1,10,/edge),yr=yr,yst=1
oplot,[0,1e6],[yr(0),yr(0)],line=2
oplot,[0,1e6],[yr(1),yr(1)],line=2
oplot,[0,1e6],[mean(rate1),mean(rate1)]

yr=mean(rate2)*[.95,1.05]
plot,smooth(rate2,10,/edge),yr=yr,yst=1
oplot,[0,1e6],[yr(0),yr(0)],line=2
oplot,[0,1e6],[yr(1),yr(1)],line=2
oplot,[0,1e6],[mean(rate2),mean(rate2)]

yr=mean(rate3)*[.95,1.05]
plot,smooth(rate3,10,/edge),yr=yr,yst=1
oplot,[0,1e6],[yr(0),yr(0)],line=2
oplot,[0,1e6],[yr(1),yr(1)],line=2
oplot,[0,1e6],[mean(rate3),mean(rate3)]
endif

; deal with big/little endian.  
; original machine writing the data was (apparently) little endian
; [intel]
volt0=data.volt0
seconds=data.seconds
byteorder,volt0,seconds,/swap_if_big_endian,/lswap

dataout.seconds = seconds
dataout.volt0 = volt0
dataout.din0  = din0
dataout.din1  = din1
dataout.din2  =din2
dataout.din3  =din3

if (keyword_set(old) ne 1) then begin
  nanoseconds=data.nanoseconds
  byteorder, nanoseconds, /swap_if_big_endian,/lswap
  dataout.nanoseconds = nanoseconds
endif

return,dataout

end
