; mirc_dataquality
; 2007Aug4 JDM
; This function will take a series of pixel values
; from the mirc_coadd (based on raw counts -- before doing 
; differences in this non-destructive read mode).
;
; there will be two signs of data quality problems that this program will
; detect.
;
;  a) if the pixels values stay the same for more than NSAME frames in a row.
;  b) if there are any abrupt changes in the readout level 
;
; ignores first 4 and last 2 reads

;return flag = 0 if good
;return flag = 1 if bad


function mirc_dataquality,data
flag=0



nsame=6
bigjump = 10 ; sigma
 ; if there is a 10sigma 

diffs=data-shift(data,1)
avgsame = smooth(abs(diffs),nsame,/edge)
avgsame=avgsame(4:(n_elements(data)-2)); ; if num<8 then crash
in=where(avgsame eq 0,ct)
if ct gt 0 then begin
  print,' At least ',nsame,' sequential reads identical'
  flag=1
endif

diffs=diffs(10:(n_elements(data)-2))
diffs=diffs-median(diffs,nsame*2) ; useing amoving median filter
   ; the endpoints of this kind of moving median filter window are
   ; not changed.

 ;to allow this program to reject saturation effects or strong
 ;flux fluctations for actually bright targets!



if (max(abs(diffs)) gt 150 ) then begin
  print,' Large jump in readout values. '
  in=where( abs(diffs) eq max(abs(diffs)))
  print,' Max jump of ',max(abs(diffs)),' at readout ',10+in(0)
  flag=1
endif

if flag eq 1 then begin
  print,'BAD DATA: FLAG =1 '
  window,0
  !p.multi=[0,1,2]
  plot,data
  plot,diffs
  ;print,'hit .c to continue'
  ;stop
endif

return,flag
end

