; JDM 2006Sep11 (ah!)
; JDM 2006Dec14 4->4a.  Spped up!
;worker routine for mirc_process4
; JDM 2006Dec26 Temporary version. Returns same as mirc_engin4a but
;		does a power spectrum with lag to help control biases.
;
; JDM 2007Jun22 made delta a keyword for coherent integration
; JDM 2007Aug23 added daqsync stuff

pro mirc_engine4x, $
    $ ;INPUTS
    num_data, ave_bg, bestfp, flux_shut,flux_fiber,flux_chop, instruct,  z0,z1_backup, $
    $ ;OUTPUTS
    mirc_data,mircx_data,vis2_base,vis2_bias, tp_tri,cp_tri,mirc_2dps,mircx_2dps,$
    ps_norms_shut,ps_norms_fiber,ps_norms_chop, nophotometry=nophotometry,$
    sigmaon=sigmaon,rp_tri=rp_tri,ip_tri=ip_tri,$
    tpbias=tpbias   ,delta=delta,$
    daqsync = flux_daqsync, ps_norms_daqsync=ps_norms_daqsync,$
    incoh_check_data = incoh_check_data, $
    incoh_check_fiber = incoh_check_fiber,$
    incoh_check_shut = incoh_check_shut,$
    incoh_check_chop = incoh_check_chop,$
    incoh_check_daqsync = incoh_check_daqsync,$
    incoh2d_check_daqsync=incoh2d_check_daqsync

if keyword_set(delta) eq 0 then delta=1

; only use z1_backup if no SATFRAME exists in the file.

;TPBIAS:
; if this complex  is present, then will substract this complex bias
; from the measured triple product in order to corret for bias.
; must have dimensions of (ntri,dimy)

;time00=systime(1)
if n_elements(sigmaon) eq 0 then sigmaon=1

; SETUP

ntel=4
nbaselines=6
ntriangles=4
ihelp=[0,0,0,1,1,2] ; map (tel i, tel j) -> baseline #
jhelp=[1,2,3,2,3,3]
trihelp=[0,0,0,1] ; tel-> tri
jtrihelp=[1,1,2,2]
iktrihelp=[2,3,3,3]
itribase=[0,0,1,3]        ; base-> tri
jtribase=[3,4,5,5]
ktribase=[1,2,2,4]

dims=size(ave_bg,/dim)
dimx=dims(0)
dimy=dims(1)
dimz=dims(2)

han=hanning(dimx)#replicate(1.d0,dimy)
han3d=rebin(han,dimx,dimy,dimz)


; Setup the matrices that will alllow FAST FAST 
; calculation of the fourier transforms.
intstart = rebin(reform(  findgen(dimx)-dimx/2 ,dimx, 1,1,1)    ,dimx,dimy,dimz,nbaselines)
fpstart  = rebin(reform(  transpose(bestfp),1,dimy,1,nbaselines),dimx,dimy,dimz,nbaselines)
rpmatrix = cos(2.0*!pi*intstart/fpstart)
ipmatrix = sin(2.0*!pi*intstart/fpstart)


biasfp = rebin(pvector([2.1, .9*min(abs(bestfp)),nbaselines]),nbaselines,dimy)
fpstart  = rebin(reform(  transpose(biasfp),1,dimy,1,nbaselines),dimx,dimy,dimz,nbaselines)
rpmatrix_bias = cos(2.0*!pi*intstart/fpstart)
ipmatrix_bias = sin(2.0*!pi*intstart/fpstart)

if keyword_set(tpbias) eq 0 then begin
  tpbias=complex(fltarr(ntriangles,dimy))
endif

tpbias3d = complex( rebin(reform(transpose((float(tpbias))),dimy,1,ntriangles),dimy,dimz,ntriangles),$
    rebin(reform(transpose((imaginary(tpbias))),dimy,1,ntriangles),dimy,dimz,ntriangles) )






mirc_data=fltarr(dimx,dimy,n_elements(num_data))
mircx_data=fltarr(dimx,dimy,n_elements(num_data))
vis2_base=fltarr(6,dimy,n_elements(num_data),2)
vis2_bias = fltarr(6,dimy,n_elements(num_data),2)
tp_tri = fltarr(4,dimy,n_elements(num_data),2)
cp_tri = fltarr(4,dimy,n_elements(num_data),2)
rp_tri = fltarr(4,dimy,n_elements(num_data),2)
ip_tri = fltarr(4,dimy,n_elements(num_data),2)





mirc_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD
mircx_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD

ps_norms_shut = fltarr(6,dimy,n_elements(num_data))
ps_norms_fiber = fltarr(6,dimy,n_elements(num_data))
ps_norms_chop  = fltarr(6,dimy,n_elements(num_data))
ps_norms_daqsync=fltarr(6,dimy,n_elements(num_data))
incoh_check_data = fltarr(dimx,dimy,n_elements(num_data))
incoh_check_shut= fltarr(dimx,dimy,n_elements(num_data))
incoh_check_fiber= fltarr(dimx,dimy,n_elements(num_data))
incoh_check_chop= fltarr(dimx,dimy,n_elements(num_data))
incoh_check_daqsync= fltarr(dimx,dimy,n_elements(num_data))
incoh2d_check_daqsync= fltarr(dimx,dimy,n_elements(num_data))



profile_fg = *flux_fiber.profile_fg  > 0
profile_fg = profile_fg/total(profile_fg) 
profile_b1 = *flux_fiber.profile_b1 > 0
profile_b2 = *flux_fiber.profile_b2 > 0
profile_b3 = *flux_fiber.profile_b3 > 0
profile_b4 = *flux_fiber.profile_b4 > 0



mirc_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD
mircx_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD

;time0=systime(1)
;print,'Header setup: ',time0-time00
;167

for i=0,n_elements(num_data)-1 do begin
;time0=systime(1)



if (keyword_set(nophotometry) ne 1) then begin

  ps_norms_shut(0,*,i)=(reform( (*flux_shut.b1) * (*flux_shut.b2 )))(i) * (total(  sqrt(profile_b1*profile_b2)*han,1))^2
  ps_norms_shut(1,*,i)=(reform( (*flux_shut.b1) * (*flux_shut.b3 )))(i) * (total(  sqrt(profile_b1*profile_b3)*han,1))^2
  ps_norms_shut(2,*,i)=(reform( (*flux_shut.b1) * (*flux_shut.b4 )))(i) * (total(  sqrt(profile_b1*profile_b4)*han,1))^2
  ps_norms_shut(3,*,i)=(reform( (*flux_shut.b2) * (*flux_shut.b3 )))(i) * (total(  sqrt(profile_b2*profile_b3)*han,1))^2
  ps_norms_shut(4,*,i)=(reform( (*flux_shut.b2) * (*flux_shut.b4 )))(i) * (total(  sqrt(profile_b2*profile_b4)*han,1))^2
  ps_norms_shut(5,*,i)=(reform( (*flux_shut.b3) * (*flux_shut.b4 )))(i) * (total(  sqrt(profile_b3*profile_b4)*han,1))^2
  incoh_check_shut(*,*,i) = (*flux_shut.b1)(i)*profile_b1 + (*flux_shut.b2)(i)*profile_b2 + $
                  (*flux_shut.b3)(i)*profile_b3 + (*flux_shut.b4)(i)*profile_b4 

  ps_norms_fiber(0,*,i)=(reform( (*flux_fiber.b1) * (*flux_fiber.b2 )))(i) * (total(  sqrt(profile_b1*profile_b2)*han,1))^2
  ps_norms_fiber(1,*,i)=(reform( (*flux_fiber.b1) * (*flux_fiber.b3 )))(i) * (total(  sqrt(profile_b1*profile_b3)*han,1))^2
  ps_norms_fiber(2,*,i)=(reform( (*flux_fiber.b1) * (*flux_fiber.b4 )))(i) * (total(  sqrt(profile_b1*profile_b4)*han,1))^2
  ps_norms_fiber(3,*,i)=(reform( (*flux_fiber.b2) * (*flux_fiber.b3 )))(i) * (total(  sqrt(profile_b2*profile_b3)*han,1))^2
  ps_norms_fiber(4,*,i)=(reform( (*flux_fiber.b2) * (*flux_fiber.b4 )))(i) * (total(  sqrt(profile_b2*profile_b4)*han,1))^2
  ps_norms_fiber(5,*,i)=(reform( (*flux_fiber.b3) * (*flux_fiber.b4 )))(i) * (total(  sqrt(profile_b3*profile_b4)*han,1))^2
  incoh_check_fiber(*,*,i) = (*flux_fiber.b1)(i)*profile_b1 + (*flux_fiber.b2)(i)*profile_b2 + $
                  (*flux_fiber.b3)(i)*profile_b3 + (*flux_fiber.b4)(i)*profile_b4 

  ps_norms_chop(0,*,i)=(reform( (*flux_chop.b1) * (*flux_chop.b2 )))(i) * (total(  sqrt(profile_b1*profile_b2)*han,1))^2
  ps_norms_chop(1,*,i)=(reform( (*flux_chop.b1) * (*flux_chop.b3 )))(i) * (total(  sqrt(profile_b1*profile_b3)*han,1))^2
  ps_norms_chop(2,*,i)=(reform( (*flux_chop.b1) * (*flux_chop.b4 )))(i) * (total(  sqrt(profile_b1*profile_b4)*han,1))^2
  ps_norms_chop(3,*,i)=(reform( (*flux_chop.b2) * (*flux_chop.b3 )))(i) * (total(  sqrt(profile_b2*profile_b3)*han,1))^2
  ps_norms_chop(4,*,i)=(reform( (*flux_chop.b2) * (*flux_chop.b4 )))(i) * (total(  sqrt(profile_b2*profile_b4)*han,1))^2
  ps_norms_chop(5,*,i)=(reform( (*flux_chop.b3) * (*flux_chop.b4 )))(i) * (total(  sqrt(profile_b3*profile_b4)*han,1))^2
  incoh_check_chop(*,*,i) = (*flux_chop.b1)(i)*profile_b1 + (*flux_chop.b2)(i)*profile_b2 + $
                  (*flux_chop.b3)(i)*profile_b3 + (*flux_chop.b4)(i)*profile_b4


if keyword_set(flux_daqsync) then begin
  ps_norms_daqsync(0,*,i)=(reform( (*flux_daqsync.b1) * (*flux_daqsync.b2 )))(i) * (total(  sqrt(profile_b1*profile_b2)*han,1))^2
  ps_norms_daqsync(1,*,i)=(reform( (*flux_daqsync.b1) * (*flux_daqsync.b3 )))(i) * (total(  sqrt(profile_b1*profile_b3)*han,1))^2
  ps_norms_daqsync(2,*,i)=(reform( (*flux_daqsync.b1) * (*flux_daqsync.b4 )))(i) * (total(  sqrt(profile_b1*profile_b4)*han,1))^2
  ps_norms_daqsync(3,*,i)=(reform( (*flux_daqsync.b2) * (*flux_daqsync.b3 )))(i) * (total(  sqrt(profile_b2*profile_b3)*han,1))^2
  ps_norms_daqsync(4,*,i)=(reform( (*flux_daqsync.b2) * (*flux_daqsync.b4 )))(i) * (total(  sqrt(profile_b2*profile_b4)*han,1))^2
  ps_norms_daqsync(5,*,i)=(reform( (*flux_daqsync.b3) * (*flux_daqsync.b4 )))(i) * (total(  sqrt(profile_b3*profile_b4)*han,1))^2
  incoh_check_daqsync(*,*,i) = (*flux_daqsync.b1)(i)*profile_b1 + (*flux_daqsync.b2)(i)*profile_b2 + $
                  (*flux_daqsync.b3)(i)*profile_b3 + (*flux_daqsync.b4)(i)*profile_b4
  for j=0,dimy -1 do begin
   pb1=profile_b1(*,j)/total(profile_b1(*,j))
   pb2=profile_b2(*,j)/total(profile_b2(*,j))
   pb3=profile_b3(*,j)/total(profile_b3(*,j))
   pb4=profile_b4(*,j)/total(profile_b4(*,j))
   incoh2d_check_daqsync(*,j,i) = (*flux_daqsync.b1_2d)(j,i) * pb1 + $
                                 (*flux_daqsync.b2_2d)(j,i) * pb2 + $
                                 (*flux_daqsync.b3_2d)(j,i) * pb3 + $
                                 (*flux_daqsync.b4_2d)(j,i) * pb4 

  endfor

endif

endif




  file0=string( instruct.dir+'/m',num_data(i),'.fits',format='(a,I4.4,a)')
print,' Processing File: ',file0


badcount=0
tryreadagain:
  td0=float(readfits(file0,head,/silent))

if n_elements(td0) eq 1 then begin
 badcount =badcount +1
 print,' BADCOUNT: ',badcount
 wait,5
 if badcount gt 100 then stop
 goto,tryreadagain

endif


  satframe=sxpar(head,'SATFRAME')-10 ; remove 10 more for safe keeping...
  if satframe le (z0+3) then satframe = dimz-1 ; incase satframe is no good.
  z1 = satframe < (dimz-10-delta) ; ignore last 10 frames. [for deltaps reasons mainly..]
  numz= z1-z0+1
  ;print,z0,z1,file0
;stop

  td0=td0-ave_bg
  td1=diffdata(td0,sigma=sigmaon)
  temp=fltarr(dimx,dimy)

;  incoh_check_data(*,*,i) = mirc_linfit3d(td0(*,*,z0:z1)) ; should be same as profiles
; found out the linfit3d is NOT the optimal way to do this!
; is biased for the case of time variable signal.

incoh_check_data(*,*,i) = (td0(*,*,z1)-td0(*,*,z0))*1.0 / (z1-z0)


if (keyword_set(nophotometry) ne 1) then begin
  ; best fit profile will be from the fiber projection.
 ; THIS NEEDS FLUX  CORRECTION!!! JDM use flux_fiber.flux_correction?
  profile_incoh = (reform(*flux_fiber.b1))(i)*profile_b1 + $
                  (reform(*flux_fiber.b2))(i)*profile_b2 + $
                  (reform(*flux_fiber.b3))(i)*profile_b3 + $
                  (reform(*flux_fiber.b4))(i)*profile_b4
 endif else profile_incoh=profile_fg

profile_incoh = profile_incoh/total(profile_incoh)


; The following will make sure that the system is normalized for
;   EACH SPECTRAL CHANNEL NOT JUST the ENTIRE channel..
profile_incoh_spec=profile_incoh


for j=0,dimy-1 do begin
  profile_incoh_spec(*,j) = profile_incoh_spec(*,j)/total(profile_incoh_spec(*,j))
 ;each spec channel is normed here.
endfor
profile_incoh3d=rebin(profile_incoh,dimx,dimy,dimz)
profile_incoh3d_spec=rebin(profile_incoh_spec,dimx,dimy,dimz)


  temptp=complexarr(dimy,dimz,ntriangles)

;time1=systime(1)
;print,'Setup: ',time1-time0


;---------------

  diffs0=(shift(td0,0,0,-delta)-td0)/delta  ; could improve SNR slightly by doing mirclinfit...
 ; ** ACTUALLY NOT NECESSARILY -- only better for readnoise dominated.

; Each SPECTRAL CHANNEL should be subtracted differently...
; since spectrum of input coupled light can shift around.
  sums2d=total(diffs0,1)
  sums2d=reform(sums2d,1,dimy,dimz)
  sums3d_new=rebin(sums2d,dimx,dimy,dimz)
  incoh3d_new = sums3d_new*profile_incoh3d_spec ; new way. 

  sums=total(total(diffs0,1),1)
  sums3d=rebin(reform(sums,1,1,dimz),dimx,dimy,dimz)
  incoh3d=sums3d*profile_incoh3d ; old way.

  diffs=(diffs0-incoh3d_new)*han3d ; try to subtract the envelope incoherent flux to help with suppression of structure from gain/envelope

  bigfft1d =fft(diffs,dim=1)
  bigps1d = float(bigfft1d)*float(bigfft1d) + imaginary(bigfft1d)*imaginary(bigfft1d)
  bigfft2d =fft(bigfft1d,dim=2)
  bigps2d  = (float(bigfft2d))^2 + (imaginary(bigfft2d))^2 ; 2x faster than above.

  mirc_data(*,*,i)=total(bigps1d(*,*,z0:z1),3)/numz
  mirc_2dps(*,*,i)=total(bigps2d(*,*,z0:z1),3)/numz

;---
; Now do some for mirxdata/ps

  bigps1dx = float(  bigfft1d*conj(shift(bigfft1d,0,0,-1)))  ; There are alternate ways to do this... 
  bigps2dx = float(  bigfft2d*conj(shift(bigfft2d,0,0,-1)))  ; that might be fun to try out.

  mircx_data(*,*,i)=total(bigps1dx(*,*,z0:z1),3)/numz
  mircx_2dps(*,*,i)=total(bigps2dx(*,*,z0:z1),3)/numz


;print,'Fill in the delta powspec:',time3-time2

;----------
; Do the direct ffts.
     diffs4d=rebin(diffs,dimx,dimy,dimz,nbaselines) ;.13s
     rp=total( rpmatrix*diffs4d   ,1)
     ip=total( ipmatrix*diffs4d   ,1)
     rpbias=total(rpmatrix_bias*diffs4d,1)
     ipbias=total(ipmatrix_bias*diffs4d,1)

     cv = complex(rp,ip)
     cvbias = complex(rpbias,ipbias)
     tempv2 = float(   cv*conj(shift( cv,0,-1,0)))
     tempv2_bias= float(    cvbias*conj(shift(cvbias,0,-1,0)) )

; Put differential phase here.
; I have everything needed! .. not quite.. opd estimator..

     cpx=complex(rp,ip)  
     ; Couldn't think of easy way to parallelize this. but should be fast.
     for tri=0,3 do begin ;  123 124 134 234 (12,13,14,23,24,34)
       
       temptp(*,*,tri) = cpx(*,*,itribase(tri))*$
                         cpx(*,*,jtribase(tri))*$
                         conj(cpx(*,*,ktribase(tri)))
   endfor
;if i eq 0 then stop
temptp=temptp-tpbias3d   ; Do bispectrum bias correction -- note that
 ; this is fairly primitive. it applies the AVERAGE bispectrum value from the 
 ; foreground data set (passed into this routine -- see process4a).  In principle,
 ; we could do better by understanding how the values scaless with flux level, etc.
 ; and by averaging mored ata together during night. Might be needed for planet finding.
  
;print,'Calc tempv2,tempv2_bias,temptp:',time4-time3
;print,'   Triangle Calc: ', time4a-time3,time4b-time4a,time4c-time4b,time4d-time4c,time4-time4d


  boot_mean_dim,tempv2(*,z0:z1,*), mns,sigs,dim=2
  vis2_base(*,*,i,0) = transpose(mns)
  vis2_base(*,*,i,1) = transpose(sigs)
  boot_mean_dim,tempv2_bias(*,z0:z1,*),mns,sigs,dim=2
  vis2_bias(*,*,i,0) = transpose(mns)
  vis2_bias(*,*,i,1) = transpose(sigs)

  boot_mean_complex_dim,temptp(*,z0:z1,*),dim=2,rp_mn,rp_sig,ip_mn,ip_sig,tp_mn,tp_sig,cp_mn,cp_sig
  tp_tri(*,*,i,0) = transpose(tp_mn)
  tp_tri(*,*,i,1) = transpose(tp_sig)
  cp_tri(*,*,i,0) = transpose(cp_mn)
  cp_tri(*,*,i,1) = transpose(cp_sig)
  rp_tri(*,*,i,0) = transpose(rp_mn)
  rp_tri(*,*,i,1) = transpose(rp_sig)
  ip_tri(*,*,i,0) = transpose(ip_mn)
  ip_tri(*,*,i,1) = transpose(ip_sig)

;print,'Do all the bootstraps:',time5-time4
;print,'total time in loop: ',time5-time0
;stop

endfor
;-------------------------


end
