; 2007Aug23 JDM  Helper program to make mirc_process3a code
;		   a bit more readable.


pro mirc_photohelper3, $
     nums, phot, phot2d,range,daqdata, beamnum,daqsm=daqsm,$  ;INPUTS
     amp_daqsync, phase_daqsync,$		  ;OUTPUT
     amp2d_daqsync, phase2d_daqsync

; nums: files to use
; phot: 1-d photometry
; phot2d; 2d photometry (per spectral channel)
; range: range of good data
; daqdata: info from daq system
; which beam to use:   'b1,'b2','b3','b4'
;daqsm=10 ; smoothing length for chopper rates
;	# of cycles to smooth over.

;OUTPUTS:
; amp_daqsync: [ (average,error), # files ]
; amp2d_daqsync: same -- but for each spectral channel
; phase_daqsync: phasor of the chopped intensities
;		 w.r.t. chopped signal on photo-interruptor
; phase2d_daqsync (2d version)

if keyword_set(daqsm) eq 0 then daqsm=10

info=size(phot2d,/dim)
dimy=info(0)
n=n_elements(nums)

amp_daqsync=fltarr(2,n)
phase_daqsync=amp_daqsync
amp2d_daqsync=fltarr(2,dimy,n)
phase2d_daqsync=amp2d_daqsync
 
if beamnum eq 'b1' then pdin=daqdata.din0
if beamnum eq 'b2' then pdin=daqdata.din1
if beamnum eq 'b3' then pdin=daqdata.din2
if beamnum eq 'b4' then pdin=daqdata.din3
if beamnum eq 'b5' then pdin=daqdata.din4
if beamnum eq 'b6' then pdin=daqdata.din5



for i=0,n-1 do begin
  print,i,' ',beamnum
  phot0 = phot(*,i)
  range0= range(*,i)
  in=where(daqdata.num eq nums(i),ct)

  if ct ne 0 then begin
    din0=*pdin(in(0))
    mirc_syncdaq,phot0,din0,range=range0, amp=amp,phase=phase,daqsm=daqsm,/docheck
   amp_daqsync(*,i) = amp
   phase_daqsync(*,i) = phase
  for j=0,dimy-1 do begin
    phot0= reform(phot2d(j,*,i))
    mirc_syncdaq,phot0,din0,range=range0, amp=amp,phase=phase,daqsm=daqsm
    amp2d_daqsync(*,j,i) = amp
    phase2d_daqsync(*,j,i) = phase
  endfor

 endif ; daqdata exists. ct ne 0
  if ct eq 0 then begin
     amp_daqsync(0,i) = 0. ; use chopper results if not sync data
     amp2d_daqsync(*,*,i) = 0.
  endif
endfor

end
