;2006Dec20	JDM
function  mirc_saturation_file,file,satframe=satframe,printit=printit,$
   addkeyword=addkeyword, flaglevel=flaglevel

; if /addkeyward 
; then add SATFRAME keyword to header and re-write fits file!

if keyword_set(flaglevel) eq 0 then flaglevel=15000.

roughsat =20000.  ; median flux must be such that median flux * dimz > roughsat

 

 ;saturation
; Load File.
; Search for Saturation.
; Returns the frame where saturation occurs (or dimz-1)
; optionally returns the satframe.
;
; TO Be USED ON COADDED DATA, NOT ORIGINAL DATA.
; expects dimensions of dimx,nspec,nframes

 im=readfits(file,head,/silent)

dims=size(im,/dim)
dimx=dims(0)
dimy=dims(1)
dimz=dims(2)

satframe=replicate(dimz-1,dimx,dimy)

; don't bother checking if < 30 frames.... [this algorithm will fail]
if dimz lt 30 then return,dimz-1


;rough level.

; First -- MOST data does not come CLOSE to saturation.
; Thus, I will only look at pixels that get over 25000 counts.


checkframe = im(*,*,dimz-10) - im(*,*,10)

test=where(checkframe gt flaglevel,ct)

if ct eq 0 then return,dimz-1 ; requires some counts above 30000.

; ok.. this is clearly a bright object.. so I will check for saturation.
; Fit a line to each pixel.

im2=diffdata(im)
nsig=3.
smoothl=10 ; smoot length

;totflux2=total( total(im2,1),1)
; Another idea is to look at the relatoin between
; the flux in pixel (amoothed) vs. the total flux in frame.
; these are strongly correlated until saturation.
; unfort.
; this won't handle dropouts at the end of file well.

for i=0,dimx-1 do begin
 for j=0,dimy-1 do begin

   a=reform(im2(i,j,*))
   as=smooth(a,smoothl,/edge)
   mm=median(as)
   ; To protect against 'dropouts', I will only ocnsider fluxes about 0.5*median. for
   ; estiamting the sigma.
   sig=robust_sigma(as(where(as gt .5*mm)))

   ; in order to make sure we aren't overly sensitive.. we should impose a minimum sigma
   ; for some quiet data whiere sig becomes unrealistically low.
   sig = sig > (mm*.1) ; say 10%.
      
  in=where(as lt (mm+nsig*sig) and as gt (mm-nsig*sig) and $
      im(i,j,*) gt flaglevel and mm gt roughsat/dimz,ct)
  if (ct gt 0 and (max(in) ne (dimz-1))) then begin
    satframe(i,j)=max(in)-smoothl
   
  endif
  

 endfor
endfor

if keyword_set(printit) then begin
in=where(satframe eq min(satframe))
print,'Saturated at Frame #',min(satframe)
print," at x,y: ",array_coords(in(0),im2)
endif

satframe0=min(satframe)

if keyword_set(addkeyword) eq 1 then begin
  locate_peak,-satframe,satx,saty
  comment = string('Saturation in frame at pixel ',satx,saty,format='(a,i2,",",i2)')
  sxaddpar,head,'SATFRAME',fix(satframe0),comment
  sxaddpar,head,'HISTORY','Added SATFRAME '+systime()
  writefits,file,im,head
endif

;stop

return,min(satframe)


end
