; mirc_syndaq
; 2007Aug23 JDM	initiation
;
;



pro mirc_syncdaq, phot0, din, range=range,amp=amp,phase=phase,$
  daqsm=daqsmooth,checkdata=checkdata,docheck=docheck

if keyword_set(dochecK) then check=1 else check=0

;check=1
info=size(phot0,/dim)
dimz=info(0)

nchunk=8 ; split into this many chunks for error analysis.
if keyword_set(daqsm) eq 0 then daqsm=10.
if (keyword_set(range) eq 0) then range=[1,n_elements(phot)-2]
z0=range(0)
z1=range(1)



phot=phot0
phot(0:(z0-1))=0.         ; zero padding
phot((z1+1):(dimz-1))=0. ; zero padding

nrange= range(1)-range(0)+1


ndaqpts=n_elements(din)   
normdaq = n_elements(din)-2 ; could try this fudge factor because timing of
			     ; camera is slightly funky in last pixel
			     ; think.
		; hopefully this won't matter actually matter..
	;NOTE. I've optimized this # for 80x8x5reads quadrants. tint 3.6ms.
	;for other timing pattenrs, this offset will change until we fix the
	;timing glitch that happens for hte last frame of mirc.


  ;setup new time base in sync with chopper.
  diff=din - shift(din,-1)
  starts=(where(diff eq 1,ct0)+.5)
  ends  =(where(diff eq -1,ct1)+.5)
    if ends(0) lt starts(0) then ends=shift(ends,-1)
    in=where(ends gt starts,ct)
    starts=starts(in)
    ends  =ends(in)
    mids=.5*(starts+ends)

;plot,deriv(smooth(mids,daqsm)),yst=1
;print,1000./mean(deriv(smooth(mids,daqsm))),stdev(deriv(smooth(mids,daqsm)))



; some of the above extra code handles the case of a chopper pulse being only half 
; recorded at either the beginning or the end..

;  newtimes_daq = interpol(findgen(ct),smooth(starts,daqsm),findgen(ndaqpts))
;  newtimes_data = interpol(newtimes_daq,findgen(ndaqpts),findgen(dimz)/(dimz*1.0)*normdaq)

; to flatten phase response near peak.
  midfringe=fix(ct*1.0*(  z0+(nrange)*.5 ) /(dimz))
  newtimes_daq = interpol(findgen(ct)-midfringe,smooth(mids,daqsm),findgen(ndaqpts))
  newtimes_data = interpol(newtimes_daq,findgen(ndaqpts),findgen(dimz)/(dimz*1.0)*normdaq)
  dt = deriv(newtimes_data)


; Check
;check=1
if (check eq 1) then begin
  hz=pvector([.98,1.02,101])
  nhz=n_elements(hz) 
  rp=fltarr(nhz)
  ip=fltarr(nhz)
  rp_prime=fltarr(nhz)
  ip_prime=fltarr(nhz)
  
  for h=0,nhz-1 do begin
  rp_prime(h)=total(dt*phot*cos(2.0*!pi*newtimes_data*hz(h)))
  ip_prime(h)=total(dt*phot*sin(2.0*!pi*newtimes_data*hz(h)))
  
  rp(h) = int_tabulated( newtimes_data, phot*cos(2.0*!pi*newtimes_data*hz(h)))
  ip(h) = int_tabulated( newtimes_data, phot*sin(2.0*!pi*newtimes_data*hz(h)))
  endfor
  ri2at,rp,ip,aa,tt
  ri2at,rp_prime,ip_prime,aa_prime,tt_prime
  checkdata=[ [hz],[aa],[tt] ]
 ; plot,hz,aa/(0.5*( newtimes_data(z1)-newtimes_data(z0) )) ,psym=-4,$
 ;  xtit="Normalized Chopper Freq",ytit="Chopped Amplitude"
 ; oplot,[1.0,1.0],[0,1e10],line=2
  ;plot,hz,tt
  ;inmax=where(aa eq max(aa))
  ;print,aa(50)/max(aa)


endif

; Do full f.transform
 norm0=0.5*(  newtimes_data(z1)-newtimes_data(z0) )
 rp0= int_tabulated( newtimes_data, phot*cos(2.0*!pi*newtimes_data*1.0))/norm0
 ip0 =int_tabulated( newtimes_data, phot*sin(2.0*!pi*newtimes_data*1.0))/norm0
ri2at,rp0,ip0,aa0,tt0

; do error bar
rps=fltarr(nchunk)
ips=fltarr(nchunk)
all_in=pvector([z0,z1,nrange])

mircblocksplitter, nrange,nchunk,1,i0s,i1s
i0s=i0s+z0
i1s=i1s+z0

for i=0,nchunk-1 do begin
 i0=i0s(i)
 i1=i1s(i)
 norm1=0.5*(  newtimes_data(i1)-newtimes_data(i0) )
 x1=newtimes_data(i0:i1)
 y1=phot(i0:i1)*cos(2.0*!pi*newtimes_data(i0:i1)*1.0)
 y2=phot(i0:i1)*sin(2.0*!pi*newtimes_data(i0:i1)*1.0)
 
 rps(i)= int_tabulated( x1,y1)/norm1
 ips(i) =int_tabulated( x1,y2)/norm1


endfor  
ri2at,rps,ips,aas,tts
array=complex(rps,ips)
boot_mean_complex_dim,array,rp_means, rp_sigmas, ip_means,ip_sigmas,$
  amp_means,amp_sigmas,phase_means,phase_sigmas,dim=dim,num=num
amp=[aa0,amp_sigmas]
phase=[tt0,phase_sigmas] ;degs

if keyword_set(check) then begin
!p.multi=[0,1,3]
 plot,hz,aa
 oplot,hz,aa_prime,line=2
 oplot,[1.0,1.0],[0,1e6]
 plot,hz,tt
 oplot,hz,tt_prime,line=2
 oplot,[1.0,1.0],[-900,900]
 plot,smooth(phot,(i1-i0),/edge)         
 oplot,(i0s+i1s)/2.,aas*2.38322,psym=4
;stop
endif
;stop
end
