function mircfix,data,sigma=sigma
;sigma = nsig for outlier removal (default = 10)


info=size(data,/dim)
; Assmume data is 3-d. (x,y,frames)
xdim=info(0)
ydim=info(1)
zdim=info(2)

ndim=3
data0=data

for i=0,info(ndim-1)-3 do begin
data0(*,*,i)=data(*,*,i+1)-data(*,*,i)
endfor
data0(*,*,i)=data0(*,*,i-1)
data0(*,*,i+1)=data0(*,*,i-1)

if (keyword_set(sigma) eq 0) then nsig=10. else nsig=sigma

; Do a sigma filter.
nch=0
nch1=0
;nsig=10.
nmed=5
for i=0,xdim-1 do begin
 for j=0,ydim-1 do begin
  y=reform(data0(i,j,*))
  medy=medsmooth(y,nmed)
  diff=y-medy
 ;FAST ROBUST RMS
  diffo=diff(sort(diff))
  rms=stdev(diffo( (.1*zdim):(.9*zdim))) > 1.
  in=where( (abs(diff) gt (nsig*rms)),ct)
  nch=nch+ct
  temp= where(in gt 5,ct1) 
  nch1=nch1+ct1
  ;if (i eq 40 and j eq 4) then stop
  if ct gt 0 then y(in)=medy(in)
  data0(i,j,*)=y
endfor
endfor
print,'Number of Pixels Changed: ',nch,' (',nch1,') out of ',n_elements(data0)



data1=data0
data0(*,*,0)=data(*,*,0)

for i=1,info(ndim-1)-1 do begin
 data0(*,*,i)=data0(*,*,i-1)+data1(*,*,i-1)
endfor

return,data0
end


