; Use same algorithm on mirkwood
; but include the opdsigns in this algorithm rather than as intermediary
; between this routine and use of BootStrapping4
; 2006Aug1 JDM
; 2006Dec12 JDM update: use cpeak0,cpeak1
; 

function mircopd, ps, cpeaks0,cpeaks1, opdsigns,wl=wl,bw=bw,wts=wts,nonorm=nonorm

if (keyword_set(wl) eq 0) then wl=1.65 ; microns
if (keyword_set(bw) eq 0) then bw=0.3 ;  microns

npeaks=n_elements(cpeaks0)
dims=size(ps,/dim)
dimx=dims(0)
dimy=dims(1)
 
result=fltarr(npeaks)
wts=fltarr(npeaks)

for p=0,npeaks -1 do begin
  xc=0
  yc=0
  for j=cpeaks0(p),cpeaks1(p) do begin
     minps=median(ps(j,*)) 
 ;print,p,j,minps
    for i=0,(dimy/2-1) do begin
 if (keyword_set(nonorm) eq 0) then begin
      xc = xc+ (ps(j,i)-minps)*cos(i*2*!pi/dimy)/minps
      yc = yc+ (ps(j,i)-minps)*sin(i*2*!pi/dimy)/minps

      xc = xc+ (ps(j,i+dimy/2)-minps)*cos(i*2*!pi/dimy - !pi)/minps
      yc = yc+ (ps(j,i+dimy/2)-minps)*sin(i*2*!pi/dimy - !pi)/minps
 endif
 if (keyword_set(nonorm) eq 1) then begin
      xc = xc+ (ps(j,i))*cos(i*2*!pi/dimy)
      yc = yc+ (ps(j,i))*sin(i*2*!pi/dimy)

      xc = xc+ (ps(j,i+dimy/2))*cos(i*2*!pi/dimy - !pi)
      yc = yc+ (ps(j,i+dimy/2))*sin(i*2*!pi/dimy - !pi)
 endif



    endfor
   endfor
  wts(p)=xc*xc+yc*yc
  result(p)= ((0.5*dimy/!pi)*atan(yc,xc)*wl*wl/bw)*opdsigns(p)
;stop
 
endfor

 return,result ; in microns
end 
