;2004Jul16 JDM
;2005May29 JDM  added errors
;2006Nov20 JDM  caltable_psnorm. passes calibration factors as array to allow fluxcal to be
; 		bootstrapped.
; 2006Dec17 JDM  generalized for t3amp... complex numbers.
;2008Jul16 JDM: correlated errors treated using diam_err

function caltables_t3amp, times_out,  times, val, val_err , cphase, t3_norm,smoothlength,$
   booterror=booterror,errweight=errweight,nsamps=nsamps,diam_err=diam_err

if keyword_set(diam_err) eq 0 then begin
  diam_err=val_err
  diam_err(*)=0
endif
; this program will assume the diam_err part of the error are all correlated 
; int he monte carlo part of the bootstrap prep.
; booterror works by doubling the smoothlength and then calculating the rror via bootstrap+MonteCarlo
; [the monte carlo part takes care of the issue of calibrator sizes at least in a rough way.


;cphase: degrees -- needed to deal with coherance between t3amp values.
; will not matter much if cphase is of high quality.

if keyword_set(nsamps) eq 0 then nsamps=30 ; 200
minwts= exp(-1.*(2.)^2) ; no penatly beyond 2Xsmoothlength.
minwts=0. ; I don't think I need this now.

cvals=fltarr(n_elements(times_out))
for ss=0,n_elements(times_out)-1 do begin

wts = ((exp(-1.*(times-times_out(ss))^2/(smoothlength)^2))>minwts)
wts2=1./     ( (val_err^2+diam_err^2)>(.05*.05))
if keyword_set(errweight) then wts=wts*wts2
 ; weight based on signal to noise, but don't give added advantag efor
 ; <5% percent error.
 t3 = complex(val*cos(cphase*!pi/180.), val*sin(cphase*!pi/180.)) 
 cvals(ss) = abs(  total(wts*t3)/total(wts*t3_norm) )
endfor

;-------------------------------
; NOW do bootstrap
booterror=cvals

results=fltarr(nsamps,n_elements(cvals))
  nvals=n_elements(val)

for i=0,nsamps-1 do begin
  val0=val+val_err*randomn(seed,nvals)+diam_err*randomn(seed,1)
  inb=fix(nvals*randomu(seed,nvals) )

btimes=times(inb)
bval_err=val_err(inb)
bdiam_err=diam_err(inb)
bval=val0(inb)
cphase_val = cphase(inb)
bt3_norm=t3_norm(inb)
bt3 = complex( bval*cos(cphase_val*!pi/180.), bval*sin(cphase_val*!pi/180.))

cvals0=fltarr(n_elements(times_out))



for ss=0,n_elements(times_out)-1 do begin

wts = ((exp(-1.*(btimes-times_out(ss))^2/(smoothlength)^2))>minwts)
wts2=1./     ( (bval_err^2+bdiam_err^2)>(.05*.05))
if keyword_set(errweight) then wts=wts*wts2

 ; weight based on signal to noise, but don't give added advantag efor
 ; <5% percent error.
 cvals0(ss) = abs( total(wts*bt3)/total(wts*bt3_norm)) - cvals(ss)
endfor

results(i,*)=cvals0
endfor

; alc error
for i=0,n_elements(times_out)-1 do begin
  booterror(i)=stdev(results(*,i))
endfor


;----------------




return,cvals
end

