; TEL ORDER: s1,s2,e1,w1,w2,e2
; 2002Sep29 JDM
; 2006Oct12 JDM  Updated with latest positions (+XYZ option for oifits)
;
; This program will return CHARA project locations and uv data for
; a given HA coverage (CHARA positions are fixed, so no CONFIG option)
; no xy_coords, since I don't know what this means... 

;***  SIMPLE VERSION **
; Used position from technical memo.
; Must get new positions (w/ x,y, and z) from THEO!

pro grab_chara_uv, ha=ha, dec=dec, $                 ;INPUTS
   xy_coords=xy_coords,b_lengths=b_lengths,b_angles=b_angles,$
    u=u,v=v ,telescope_positions=telescope_positions,$
    xyz=xyz

;xy_coords/b_angles correspond to an equivalent paerture mask
;for IOTA since this program will be used by keckmrg_input.
;
;In the future I should write something that puts out REAL STUFF!!!
; 
; XYZ is the telescope positions in RELATIVE XYZ coords (to S1)

num_ha=n_elements(ha)

xy_coords=dblarr(6,2,num_ha)
b_lengths=dblarr(6,6,num_ha)
b_angles=dblarr(6,6,num_ha)
u=dblarr(6,6,num_ha)
v=dblarr(6,6,num_ha)

; Set up internal chara positions
file='/n/51peg2/Monnier/Idlstuff/CHARA/chara_xyz.txt'
if nlines(file) eq 0 then begin
 ; check somewhere else
file='./chara_xyz.txt'
if nlines(file) eq 0 then file=dialog_pickfile(tit="Choose the chara_xyz.txt file:")
endif


nl=nlines(file)
ez=dblarr(nl-1)
nz=dblarr(nl-1)
uz=dblarr(nl-1)


openr,unit,file,/get
a=' '
readf,unit,a
for i=0,nl-2 do begin
 readf,unit,a
; print,i,a
 av=string_vector(a)
 ez(i)=double(av(1))/1d6
 nz(i)=double(av(2))/1d6
 uz(i)=double(av(3))/1d6
endfor
close,unit
free_lun,unit
; ORDER: S1 S2 E1 W1 W2 E2

telescope_positions=[  [ez(0),nz(0),uz(0)],$
                       [ez(1),nz(1),uz(1)],$
                       [ez(2),nz(2),uz(2)],$
                       [ez(3),nz(3),uz(3)],$
                       [ez(4),nz(4),uz(4)],$
                       [ez(5),nz(5),uz(5)] ]

num_ha=n_elements(ha)
chara_lat = 34.d0+13./60d0+27.78130d0/3600.d0  ;deg
chara_long = -118. - 3./60d0 -25.31272/3600. ; degs
; Convert Tel positions to XYZ for OI -FITS
xyz=dblarr(3,6)
xyz2=geocoord(telescope_positions,chara_lat,chara_long)
  xyz(0,*)=xyz2.x
  xyz(1,*)=xyz2.y
  xyz(2,*)=xyz2.z

;stop

;stop
; go through each baseline
for i=0,5 do begin
 for j=0,5 do begin
bv = [ez(j)-ez(i),nz(j)-nz(i),uz(j)-uz(i)]
 calc_uv,ha=ha,u=u1,v=v1,w=w,dec=dec,baseline =bv, lat=chara_lat
;stop
; I will need to put a rotation and maybe sign flip here to get image to 
; look right.
if (i eq 0) then begin
  xy_coords(j,0,*)=u1
  xy_coords(j,1,*)=v1
endif

ri2at,u1,v1,a1,t1

u(i,j,*)=u1
v(i,j,*)=v1
b_lengths(i,j,*)=a1
b_angles(i,j,*)=t1*!pi/180.

endfor
endfor
end

