; 2003Jun28 JDM, created for keck->oidata
; 2003Jun30 JDM modified for iota-fluor
; 2300Sep24 JDM modified for IONIC3 data [still not ARRAYS, only data.]
; 2004Jun08 JDM modified for new version of software
;	    (3 I1-I2 channels, multiple targets, still no oi-arrays)
; 2004Jun28 JDM fixed bug (ra was in hrs, not degrees as called for in standard)
; 2006Sep14 JDM modified for CHARA-MIRC 
;	still not including oi-array (but will!, I promise)

; This routine will write oidata format based on calibrated Vis^2 data
; based on IONIC data. Also will try OI-T3 data with the closure phases.

; For the moment, this routine will only work with one observing date
; at a time!
; must use mergeoidata to combine sets.

; * as of now I have not
;confirmed closure phase sign for CHARA/MIRC (HIGH ON LIST !) 
; 2006Sep14
;
; 
pro mirc2oidata, obs_date0,obs_times,int_time, mjds, uu_meters,vv_meters,vis2,vis2_err,$
  cphase,cphaseerr, tramp,tramperr,lambda,lambdaerr,$
  target, ra, dec, specname, telindex,file=file

;obs_date '2003-02-22'
;obs_times: float UT times
;
; if only one obs_date0, then assume all obs_times on same day. otherwise
; use array of obs_dates
if (n_elements(obs_date0) eq 1) then begin
  obs_dates=replicate(obs_date0,n_elements(obs_times))
endif else obs_dates=obs_date0

; NO ARRAY! to be done later...
;goto,skip_array

define_oiarray,oiarray_unit
;TEL ORDER: s1,s2,e1,w1,w2,e2
; in reality, its simpler to always define the 6 chara tels.
; however! for some applications its easier to break up into 4-tel arrays.
; I will  make this an option someday
; to write all six, simply write: tin=[0,1,2,3,4,6]
tin=telindex
ntel=n_elements(tin)
tnames=strarr(ntel)
for i=0,ntel-1 do begin
 if tin(i) eq 0 then tnames(i)='S1'
 if tin(i) eq 1 then tnames(i)='S2'
 if tin(i) eq 2 then tnames(i)='E1'
 if tin(i) eq 3 then tnames(i)='W1'
 if tin(i) eq 4 then tnames(i)='W2'
 if tin(i) eq 5 then tnames(i)='E2'
endfor
ssin=sort(tin)
grab_chara_uv,ha=[0.01],dec=0.0,xyz=xyz
;view 

oiarray=replicate(oiarray_unit,ntel)

oiarray.extver=1
oiarray.arrname="CHARA"
oiarray.frame = "GEOCENTRIC"
oiarray.arrayx =  0.0
oiarray.arrayy =  0.0
oiarray.arrayz =  0.0
oiarray.tel_name = tnames(ssin) 
oiarray.sta_name = tnames(ssin)
oiarray.sta_index = tin(ssin)
oiarray.diameter = 1.0

for i=0,ntel-1 do begin
oiarray(i).staxyz = reform(xyz(*,tin(ssin(i))))
endfor

skip_array:
;-----------------------------------------
define_oitarget,oitarget_unit

;find uniq targets
uniq_in=uniq(target,sort(target))
ntargets=n_elements(uniq_in)

oitarget=replicate(oitarget_unit,ntargets)
targetnums=intarr(n_elements(target))

for i=0,ntargets-1 do begin
ti=uniq_in(i)
ins=where(target eq target(ti))
targetnums(ins)=i

oitarget(i).target_id = i
oitarget(i).target = target(ti)
oitarget(i).raep0 = ra(ti) ; DEGREES
oitarget(i).decep0 = dec(ti)
oitarget(i).equinox = 2000.0
oitarget(i).ra_err = -1
oitarget(i).dec_err = -1
oitarget(i).sysvel = -1
oitarget(i).veltyp = ["LSR"]
oitarget(i).veldef = ["OPTICAL"]
oitarget(i).pmra = -1
oitarget(i).pmdec = -1
oitarget(i).pmra_err = -1
oitarget(i).pmdec_err = -1
oitarget(i).parallax = -1
oitarget(i).para_err=-1
oitarget(i).spectyp = ["Unknown"]

endfor
;-------------------------------------------
nwave=n_elements(lambda)
define_oiwavelength,oiwavelength_unit,nwave=nwave
 oiwavelength=oiwavelength_unit
 oiwavelength.extver=1
 oiwavelength.insname=specname
 oiwavelength.eff_wave = ptr_new(lambda) ; average of band
 oiwavelength.eff_band = ptr_new(lambdaerr)

;define_oiwavelength,oiwavelength_unit,nwave=20
; oiwavelength=concat_oitable(oiwavelength,oiwavelength_unit)
; oiwavelength(1).extver=1
;oiwavelength(1).insname="CHARA_MIRC"
;oiwavelength(1).eff_wave = ptr_new( (findgen(20)/20+1.4)*1e-6)
;oiwavelength(1).eff_band = ptr_new( replicate(.05,20)*1e-6 )
;
;-----------------------------------------------------
;NO OIVIS
goto,skip_oivis
nwave=n_elements(lambda)
define_oivis, oivis_unit, nwave= nwave
oivis=replicate(oivis_unit,9)
oivis(*).extver=1
oivis(*).date_obs='2002-12-17'
oivis(*).arrname ="IOTA_2002Dec17"
oivis(*).insname ="IOTA_IONIC_PICNIC"
oivis(*).target_id = [0,0,0,1,1,1,0,0,0]
oivis(*).time = 100*findgen(9)
oivis(*).mjd   = 100*findgen(9)/3600./24.
oivis(*).int_time = 20.
for i=0,8 do begin
 oivis(i).visamp =ptr_new(i/10.)
 oivis(i).visamperr = ptr_new(.05)
 oivis(i).visphi = ptr_new(i*10.)
 oivis(i).visphierr = ptr_new(10.)
 oivis(i).ucoord    = i*10.
 oivis(i).vcoord    = -i*10.
 oivis(i).sta_index  = [i mod 3, (i+1) mod 3 ]
 if (i mod 2) then oivis(i).flag       = ptr_new(byte("T")) $
             else  oivis(i).flag = ptr_new(byte("F"))
endfor

define_oivis, oivis_unit, nwave= 20
oivis0=replicate(oivis_unit,3)
oivis0(*).extver=2
oivis0(*).date_obs='2004-01-11'
oivis0(*).arrname ="MIRC4"
oivis0(*).insname =specname
oivis0(*).target_id = [0,1,2]
oivis0(*).time = 10*findgen(3)
oivis0(*).mjd   = 10*findgen(3)/3600./24.
oivis0(*).int_time = 2.
for i=0,2 do begin
 oivis0(i).visamp =ptr_new( (i+findgen(20))/20.)
 oivis0(i).visamperr = ptr_new(replicate(.02,20))
 oivis0(i).visphi = ptr_new( findgen(20)*10+10*i )
 oivis0(i).visphierr = ptr_new(replicate(1.0,20))
 oivis0(i).ucoord    = i*50.
 oivis0(i).vcoord    = -i*50.
 oivis0(i).sta_index  = [3,5]
 if (i mod 2) then oivis0(i).flag       = ptr_new(byte("TTFFFFFTTTFFFFFFFFFF")) $
             else  oivis0(i).flag = ptr_new(byte("FFFFFTTTTTFFFFFTTTTT"))
endfor

oivis=concat_oitable(oivis,oivis0)
;--------------------------------------------------------
skip_oivis:


jdcnv,strmid(obs_dates,0,4),strmid(obs_dates,5,2),strmid(obs_dates,8,2),$
 0.0, jd0s
in0=(where(jd0s eq min(jd0s)))(0)
official_obs_date = obs_dates(in0)
times = 24.0d0*3600.d0*(jd0s-jd0s(in0)) + obs_times

define_oivis2, oivis2_unit, nwave= nwave
num=n_elements(obs_dates) ; only write 'good' data
oivis2=replicate(oivis2_unit,num)
oivis2(*).extver=1
oivis2(*).date_obs=official_obs_date
oivis2(*).arrname ="CHARA"
oivis2(*).insname = specname
oivis2(*).target_id = targetnums
oivis2(*).time = times 
oivis2(*).mjd   = mjds
oivis2(*).int_time = int_time
for i=0,num-1 do begin
 oivis2(i).vis2data =ptr_new(reform(vis2(0,*,i))) ; vector if many lambdas
 oivis2(i).vis2err = ptr_new(reform(vis2_err(0,*,i)))
 oivis2(i).ucoord    = uu_meters(0,i)
 oivis2(i).vcoord    = vv_meters(0,i)
 oivis2(i).sta_index  = [telindex(0),telindex(1)]
 oivis2(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis2(i).flag       = ptr_new(byte("T")) $
;             else  oivis2(i).flag = ptr_new(byte("F"))
endfor

oivis0=replicate(oivis2_unit,num)
oivis0(*).extver=1
oivis0(*).date_obs=official_obs_date
oivis0(*).arrname ="CHARA"
oivis0(*).insname = specname
oivis0(*).target_id = targetnums
oivis0(*).time = times
oivis0(*).mjd   = mjds
oivis0(*).int_time = int_time
for i=0,num-1 do begin
 oivis0(i).vis2data =ptr_new(reform(vis2(1,*,i)) ); vector if many lambdas
 oivis0(i).vis2err = ptr_new(reform(vis2_err(1,*,i)))
 oivis0(i).ucoord    = uu_meters(1,i)
 oivis0(i).vcoord    = vv_meters(1,i)
 oivis0(i).sta_index  = [telindex(0),telindex(2)]
 oivis0(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis0(i).flag       = ptr_new(byte("T")) $
;             else  oivis0(i).flag = ptr_new(byte("F"))
endfor


oivis2=concat_oitable(oivis2,oivis0)

oivis0=replicate(oivis2_unit,num)
oivis0(*).extver=1
oivis0(*).date_obs=official_obs_date
oivis0(*).arrname ="CHARA"
oivis0(*).insname = specname
oivis0(*).target_id = targetnums
oivis0(*).time = times
oivis0(*).mjd   = mjds
oivis0(*).int_time = int_time
for i=0,num-1 do begin
 oivis0(i).vis2data =ptr_new(reform(vis2(2,*,i))) ; vector if many lambdas
 oivis0(i).vis2err = ptr_new(reform(vis2_err(2,*,i)))
 oivis0(i).ucoord    = uu_meters(2,i)
 oivis0(i).vcoord    = vv_meters(2,i)
 oivis0(i).sta_index  = [telindex(0),telindex(3)]
 oivis0(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis0(i).flag       = ptr_new(byte("T")) $
;             else  oivis0(i).flag = ptr_new(byte("F"))
endfor

 
oivis2=concat_oitable(oivis2,oivis0)

oivis0=replicate(oivis2_unit,num)
oivis0(*).extver=1
oivis0(*).date_obs=official_obs_date
oivis0(*).arrname ="CHARA"
oivis0(*).insname = specname
oivis0(*).target_id = targetnums
oivis0(*).time = times
oivis0(*).mjd   = mjds
oivis0(*).int_time = int_time
for i=0,num-1 do begin
 oivis0(i).vis2data =ptr_new(reform(vis2(3,*,i))) ; vector if many lambdas
 oivis0(i).vis2err = ptr_new(reform(vis2_err(3,*,i)))
 oivis0(i).ucoord    = uu_meters(3,i)
 oivis0(i).vcoord    = vv_meters(3,i)
 oivis0(i).sta_index  = [telindex(1),telindex(2)]
 oivis0(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis0(i).flag       = ptr_new(byte("T")) $
;             else  oivis0(i).flag = ptr_new(byte("F"))
endfor


oivis2=concat_oitable(oivis2,oivis0)

oivis0=replicate(oivis2_unit,num)
oivis0(*).extver=1
oivis0(*).date_obs=official_obs_date
oivis0(*).arrname ="CHARA"
oivis0(*).insname = specname
oivis0(*).target_id = targetnums
oivis0(*).time = times
oivis0(*).mjd   = mjds
oivis0(*).int_time = int_time
for i=0,num-1 do begin
 oivis0(i).vis2data =ptr_new(reform(vis2(4,*,i))) ; vector if many lambdas
 oivis0(i).vis2err = ptr_new(reform(vis2_err(4,*,i)))
 oivis0(i).ucoord    = uu_meters(4,i)
 oivis0(i).vcoord    = vv_meters(4,i)
 oivis0(i).sta_index  = [telindex(1),telindex(3)]
 oivis0(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis0(i).flag       = ptr_new(byte("T")) $
;             else  oivis0(i).flag = ptr_new(byte("F"))
endfor


oivis2=concat_oitable(oivis2,oivis0)

oivis0=replicate(oivis2_unit,num)
oivis0(*).extver=1
oivis0(*).date_obs=official_obs_date
oivis0(*).arrname ="CHARA"
oivis0(*).insname = specname
oivis0(*).target_id = targetnums
oivis0(*).time = times
oivis0(*).mjd   = mjds
oivis0(*).int_time = int_time
for i=0,num-1 do begin
 oivis0(i).vis2data =ptr_new(reform(vis2(5,*,i))) ; vector if many lambdas
 oivis0(i).vis2err = ptr_new(reform(vis2_err(5,*,i)))
 oivis0(i).ucoord    = uu_meters(5,i)
 oivis0(i).vcoord    = vv_meters(5,i)
 oivis0(i).sta_index  = [telindex(2),telindex(3)]
 oivis0(i).flag = ptr_new(byte("F"))
; if (i mod 2) then oivis0(i).flag       = ptr_new(byte("T")) $
;             else  oivis0(i).flag = ptr_new(byte("F"))
endfor

oivis2=concat_oitable(oivis2,oivis0)





;-------------------------------------------------

;---------------
; oit3 part assumes you already calculated stuff above for the
;oivis2 table
;
; MORE work will be needed for this data writer when not all baselins
; and closure phases are available.
define_oit3, oit3_unit, nwave=nwave 
;ct=n_elements(cphase)
oit3=replicate(oit3_unit,num)
oit3(*).extver=1
oit3(*).date_obs=official_obs_date
oit3(*).arrname ="CHARA"
oit3(*).insname =specname
oit3(*).target_id = targetnums
oit3(*).time = times
oit3(*).mjd   = mjds
oit3(*).int_time = int_time
; *** SIGN OF CLOSURE PHASE TRIANGLE NOT KNOWN HERE YET!!!!
; 2006Sep15
for i=0,num-1 do begin
 oit3(i).t3amp =ptr_new(tramp(i))
 oit3(i).t3amperr = ptr_new(tramperr(i))
; must fix up tramp
 oit3(i).t3phi = ptr_new( reform(cphase(0,*) ))
 oit3(i).t3phierr = ptr_new( reform(cphaseerr(0,*) ))
 oit3(i).u1coord    = uu_meters(0,i)
 oit3(i).v1coord    = vv_meters(0,i)
 oit3(i).u2coord    = uu_meters(3,i)
 oit3(i).v2coord    = vv_meters(3,i)
 oit3(i).sta_index  = [telindex(0),telindex(1),telindex(2)]
 oit3(i).flag  = ptr_new(byte("F")) 
;if (i mod 2) then oit3(i).flag       = ptr_new(byte("T")) $
;             else  oit3(i).flag = ptr_new(byte("F"))
endfor
;----------------------------
oit3a=replicate(oit3_unit,num)
oit3a(*).extver=1
oit3a(*).date_obs=official_obs_date
oit3a(*).arrname ="CHARA"
oit3a(*).insname =specname
oit3a(*).target_id = targetnums
oit3a(*).time = times
oit3a(*).mjd   = mjds
oit3a(*).int_time = int_time
; *** SIGN OF CLOSURE PHASE TRIANGLE NOT KNOWN HERE YET!!!!
; 2006Sep15
for i=0,num-1 do begin
 oit3a(i).t3amp =ptr_new(tramp(i))
 oit3a(i).t3amperr = ptr_new(tramperr(i))
; must fix up tramp
 oit3a(i).t3phi = ptr_new( reform(cphase(1,*) ))
 oit3a(i).t3phierr = ptr_new( reform(cphaseerr(1,*) ))
 oit3a(i).u1coord    = uu_meters(0,i)
 oit3a(i).v1coord    = vv_meters(0,i)
 oit3a(i).u2coord    = uu_meters(4,i)
 oit3a(i).v2coord    = vv_meters(4,i)
 oit3a(i).sta_index  = [telindex(0),telindex(1),telindex(3)]
 oit3a(i).flag  = ptr_new(byte("F"))
;if (i mod 2) then oit3(i).flag       = ptr_new(byte("T")) $
;             else  oit3(i).flag = ptr_new(byte("F"))
endfor

oit3=concat_oitable(oit3,oit3a)

;----------------------------
oit3a=replicate(oit3_unit,num)
oit3a(*).extver=1
oit3a(*).date_obs=official_obs_date
oit3a(*).arrname ="CHARA"
oit3a(*).insname =specname
oit3a(*).target_id = targetnums
oit3a(*).time = times
oit3a(*).mjd   = mjds
oit3a(*).int_time = int_time
; *** SIGN OF CLOSURE PHASE TRIANGLE NOT KNOWN HERE YET!!!!
; 2006Sep15
for i=0,num-1 do begin
 oit3a(i).t3amp =ptr_new(tramp(i))
 oit3a(i).t3amperr = ptr_new(tramperr(i))
; must fix up tramp
 oit3a(i).t3phi = ptr_new( reform(cphase(2,*) ))
 oit3a(i).t3phierr = ptr_new( reform(cphaseerr(2,*) ))
 oit3a(i).u1coord    = uu_meters(1,i)
 oit3a(i).v1coord    = vv_meters(1,i)
 oit3a(i).u2coord    = uu_meters(5,i)
 oit3a(i).v2coord    = vv_meters(5,i)
 oit3a(i).sta_index  = [telindex(0),telindex(2),telindex(3)]
 oit3a(i).flag  = ptr_new(byte("F"))
;if (i mod 2) then oit3(i).flag       = ptr_new(byte("T")) $
;             else  oit3(i).flag = ptr_new(byte("F"))
endfor
oit3=concat_oitable(oit3,oit3a)
;----------------------------
oit3a=replicate(oit3_unit,num)
oit3a(*).extver=1
oit3a(*).date_obs=official_obs_date
oit3a(*).arrname ="CHARA"
oit3a(*).insname =specname
oit3a(*).target_id = targetnums
oit3a(*).time = times
oit3a(*).mjd   = mjds
oit3a(*).int_time = int_time
; *** SIGN OF CLOSURE PHASE TRIANGLE NOT KNOWN HERE YET!!!!
; 2006Sep15
for i=0,num-1 do begin
 oit3a(i).t3amp =ptr_new(tramp(i))
 oit3a(i).t3amperr = ptr_new(tramperr(i))
; must fix up tramp
 oit3a(i).t3phi = ptr_new( reform(cphase(3,*) ))
 oit3a(i).t3phierr = ptr_new( reform(cphaseerr(3,*) ))
 oit3a(i).u1coord    = uu_meters(3,i)
 oit3a(i).v1coord    = vv_meters(3,i)
 oit3a(i).u2coord    = uu_meters(5,i)
 oit3a(i).v2coord    = vv_meters(5,i)
 oit3a(i).sta_index  = [telindex(1),telindex(2),telindex(3)]
 oit3a(i).flag  = ptr_new(byte("F"))
;if (i mod 2) then oit3(i).flag       = ptr_new(byte("T")) $
;             else  oit3(i).flag = ptr_new(byte("F"))
endfor
oit3=concat_oitable(oit3,oit3a)


;----------------------------

goto,skip_nextoit3
define_oit3, oit3_unit, nwave= 20
oit4=replicate(oit3_unit,3)
oit4(*).extver=2
oit4(*).date_obs='2004-01-11'
oit4(*).arrname ="CHARA_2004Jan"
oit4(*).insname ="CHARA_MIRC"
oit4(*).target_id = [0,1,2]
oit4(*).time = 10*findgen(3)
oit4(*).mjd   = 10*findgen(3)/3600./24.
oit4(*).int_time = 2.
for i=0,2 do begin
 oit4(i).t3amp =ptr_new( (i+findgen(20))/20.)
 oit4(i).t3amperr = ptr_new(replicate(.02,20))
 oit4(i).t3phi = ptr_new( findgen(20)*10+10*i )
 oit4(i).t3phierr = ptr_new(replicate(1.0,20))
 oit4(i).u1coord    = i*100.
 oit4(i).v1coord    = -i*100.
 oit4(i).u2coord    = -i*200.
 oit4(i).v2coord    = i*200.

 oit4(i).sta_index  = [3,5,1]
 if (i mod 2) then oit4(i).flag       = ptr_new(byte("TTFFFFFTTTFFFFFFFFFF")) $
             else  oit4(i).flag = ptr_new(byte("FFFFFTTTTTFFFFFTTTTT"))
endfor

oit3=concat_oitable(oit3,oit4)
skip_nextoit3:
skip_oit3:

write_oidata,file,oiarray,oitarget,oiwavelength,oivis,oivis2,oit3
end



