; JDM 2006Sep11 (ah!)
;worker routine for mirc_process4
;
; IMPROVEMENTS: Add Coherent Integration for both Vis2 and Triple Amplitude/CP.
; 		[Add as keyword]

pro mirc_engine4, $
    $ ;INPUTS
    num_data, ave_bg, bestfp, flux_shut,flux_fiber,flux_chop, instruct,  z0,z1, $
    $ ;OUTPUTS
    mirc_data,mircx_data,vis2_base,vis2_bias, tp_tri,cp_tri,mirc_2dps,mircx_2dps,$
    ps_norms_shut,ps_norms_fiber,ps_norms_chop, nophotometry=nophotometry,$
    sigmaon=sigmaon

if n_elements(sigmaon) eq 0 then sigmaon=1





; SETUP
dims=size(ave_bg,/dim)
 dimx=dims(0)
 dimy=dims(1)
 dimz=dims(2)
 han=hanning(dimx)#replicate(1.d0,dimy)
 numz = z1-z0+1


mirc_data=fltarr(dimx,dimy,n_elements(num_data))
mircx_data=fltarr(dimx,dimy,n_elements(num_data))
vis2_base=fltarr(6,dimy,n_elements(num_data),2)
vis2_bias = fltarr(6,dimy,n_elements(num_data),2)
biasfp = pvector([2.1, .9*min(abs(bestfp)),6])
tp_tri = fltarr(4,dimy,n_elements(num_data),2)
cp_tri = fltarr(4,dimy,n_elements(num_data),2)

mirc_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD
mircx_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD

Ps_norms_shut = fltarr(dimx,dimy,6,n_elements(num_data))
ps_norms_fiber = fltarr(dimx,dimy,6,n_elements(num_data))
ps_norms_chop  = fltarr(dimx,dimy,6,n_elements(num_data))

profile_fg = *flux_fiber.profile_fg  > 0
profile_fg = profile_fg/total(profile_fg) 
profile_b1 = *flux_fiber.profile_b1 > 0
profile_b2 = *flux_fiber.profile_b2 > 0
profile_b3 = *flux_fiber.profile_b3 > 0
profile_b4 = *flux_fiber.profile_b4 > 0


;mirc_data=fltarr(dimx,dimy,n_elements(num_data))
;mircx_data=fltarr(dimx,dimy,n_elements(num_data))
;vis2_base=fltarr(6,dimy,n_elements(num_data),2)
;vis2_bias = fltarr(6,dimy,n_elements(num_data),2)
;biasfp = pvector([2.1, .9*min(abs(bestfp)),6])
;tp_tri = complexarr(4,dimy,n_elements(num_data),2)
;cp_tri = fltarr(4,dimy,n_elements(num_data),2)

mirc_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD
mircx_2dps=fltarr(dimx,dimy,n_elements(num_data)); for OPD


for i=0,n_elements(num_data)-1 do begin

if (keyword_set(nophotometry) ne 1) then begin
; the norm factor will be squared at the end of this routine.

  ps_norms_shut(*,*,0,i)=sqrt((reform(*flux_shut.b1 * (*flux_shut.b2 )))(i) * profile_b1*profile_b2)*han
  ps_norms_shut(*,*,1,i)=sqrt((reform(*flux_shut.b1 * (*flux_shut.b3 )))(i) * profile_b1*profile_b3)*han
  ps_norms_shut(*,*,2,i)=sqrt((reform(*flux_shut.b1 * (*flux_shut.b4 )))(i) * profile_b1*profile_b4)*han
  ps_norms_shut(*,*,3,i)=sqrt((reform(*flux_shut.b2 * (*flux_shut.b3 )))(i) * profile_b2*profile_b3)*han
  ps_norms_shut(*,*,4,i)=sqrt((reform(*flux_shut.b2 * (*flux_shut.b4 )))(i) * profile_b2*profile_b4)*han
  ps_norms_shut(*,*,5,i)=sqrt((reform(*flux_shut.b3 * (*flux_shut.b4 )))(i) * profile_b3*profile_b4)*han
  ps_norms_fiber(*,*,0,i)=sqrt((reform(*flux_fiber.b1 * (*flux_fiber.b2 )))(i)* profile_b1*profile_b2)*han
  ps_norms_fiber(*,*,1,i)=sqrt((reform(*flux_fiber.b1 * (*flux_fiber.b3 )))(i)* profile_b1*profile_b3)*han
  ps_norms_fiber(*,*,2,i)=sqrt((reform(*flux_fiber.b1 * (*flux_fiber.b4 )))(i)* profile_b1*profile_b4)*han
  ps_norms_fiber(*,*,3,i)=sqrt((reform(*flux_fiber.b2 * (*flux_fiber.b3 )))(i)* profile_b2*profile_b3)*han
  ps_norms_fiber(*,*,4,i)=sqrt((reform(*flux_fiber.b2 * (*flux_fiber.b4 )))(i)* profile_b2*profile_b4)*han
  ps_norms_fiber(*,*,5,i)=sqrt((reform(*flux_fiber.b3 * (*flux_fiber.b4 )))(i)* profile_b3*profile_b4)*han
  ps_norms_chop(*,*,0,i)=sqrt((reform(*flux_chop.b1 * (*flux_chop.b2 )))(i)* profile_b1*profile_b2)*han
  ps_norms_chop(*,*,1,i)=sqrt((reform(*flux_chop.b1 * (*flux_chop.b3 )))(i)* profile_b1*profile_b3)*han
  ps_norms_chop(*,*,2,i)=sqrt((reform(*flux_chop.b1 * (*flux_chop.b4 )))(i)* profile_b1*profile_b4)*han
  ps_norms_chop(*,*,3,i)=sqrt((reform(*flux_chop.b2 * (*flux_chop.b3 )))(i)* profile_b2*profile_b3)*han
  ps_norms_chop(*,*,4,i)=sqrt((reform(*flux_chop.b2 * (*flux_chop.b4 )))(i)* profile_b2*profile_b4)*han
  ps_norms_chop(*,*,5,i)=sqrt((reform(*flux_chop.b3 * (*flux_chop.b4 )))(i)* profile_b3*profile_b4)*han
endif


  file0=string( instruct.dir+'/COADD/m',num_data(i),'.fits',format='(a,I4.4,a)')
print,' Processing File: ',file0
  td0=float(readfits(file0))-ave_bg
  td1=diffdata(td0,sigma=sigmaon)
  temp=fltarr(dimx,dimy)

if (keyword_set(nophotometry) ne 1) then begin
  ; best fit profile will be from the fiber projection.
  profile_incoh = (reform(*flux_fiber.b1))(i)*profile_b1 + $
                  (reform(*flux_fiber.b2))(i)*profile_b2 + $
                  (reform(*flux_fiber.b3))(i)*profile_b3 + $
                  (reform(*flux_fiber.b4))(i)*profile_b4
 endif else profile_incoh=profile_fg

  profile_incoh = profile_incoh/total(profile_incoh)

  tempv2=fltarr(6,numz,dimy)
  tempv2_bias=fltarr(6,numz,dimy)
  temptp=complexarr(4,numz,dimy)
  for j=z0,z1 do begin
     diff0=td1(*,*,j)
;     diff1= diff0
     diff1=(diff0-(profile_incoh*total(diff0))) * han
     mirc_2dps(*,*,i)=mirc_2dps(*,*,i)+(abs(fft(diff1)))^2
   for k=0,dimy-1 do begin
     diff=diff1(*,k)
     temp(*,k)=temp(*,k)+(abs(fft(diff)))^2
     for base=0,5 do begin 
       rp=total(diff*cos(2.0*!pi*findgen(dimx)/bestfp(base,k)))
       ip=total(diff*sin(2.0*!pi*findgen(dimx)/bestfp(base,k)))
       tempv2(base,j-z0,k) = rp*rp+ip*ip
     endfor
     for base=0,5 do begin 
       rp=total(diff*cos(2.0*!pi*findgen(dimx)/biasfp(base)))
       ip=total(diff*sin(2.0*!pi*findgen(dimx)/biasfp(base)))
       tempv2_bias(base,j-z0,k) = rp*rp+ip*ip
     endfor
     for tri=0,3 do begin ;  123 124 134 234 (12,13,14,23,24,34)
       if tri eq 0 then begin ; 123
          bases=[0,3,1]
       endif
       if tri eq 1 then begin ;124
          bases=[0,4,2]
       endif
       if tri eq 2 then begin ;134
          bases=[1,5,2]
       endif
       if tri eq 3 then begin ;234
          bases=[3,5,4]
       endif
     ; Norm is somewhat different here between vis2 and t3amp. any good reason?
     ; difference is fixed upin mirc_reduce.script but maybe this should be
     ; reformed someday. -jdm 2006Nov26 
       rp1=total(diff*cos(2.0*!pi*findgen(dimx)/bestfp(bases(0),k)))
       ip1=total(diff*sin(2.0*!pi*findgen(dimx)/bestfp(bases(0),k)))
       rp2=total(diff*cos(2.0*!pi*findgen(dimx)/bestfp(bases(1),k)))
       ip2=total(diff*sin(2.0*!pi*findgen(dimx)/bestfp(bases(1),k)))
       rp3=total(diff*cos(2.0*!pi*findgen(dimx)/bestfp(bases(2),k)))
       ip3=total(-1.0*diff*sin(2.0*!pi*findgen(dimx)/bestfp(bases(2),k)))

       temptp(tri,j-z0,k)=complex(rp1,ip1)*complex(rp2,ip2)*complex(rp3,ip3)
    endfor
   endfor
 endfor
;  if i eq 31 then stop
  mirc_data(*,*,i)=temp/numz
  ; tp_tri(*,*,i)=temptp/numz
  ;vis2_base(*,*,i)=tempv2/numz


temp=fltarr(dimx,dimy)
  for j=z0,z1 do begin
     delta=8 ; 1 is minimum : coherent integration.
     diff0=reform(td0(*,*,j+delta)-td0(*,*,j))/delta
     diff1=(diff0-(profile_incoh*total(diff0))) * han
     diff10=reform(td0(*,*,j+1+delta)-td0(*,*,j+1))/delta
     diff11=(diff10-(profile_incoh*total(diff10)) ) * han
     mircx_2dps(*,*,i)=mircx_2dps(*,*,i)+fft(shift(diff1,-dimx/2,-dimy/2))*conj(fft(shift(diff11,-dimx/2,-dimy/2)))

  for k=0,dimy-1 do begin
     diff=reform(diff1(*,k))
     diff2=reform(diff11(*,k))
     ftemp=fft(shift(diff,-dimx/2))*conj(fft(shift(diff2,-dimx/2)))
     temp(*,k)=temp(*,k)+float(ftemp)
   endfor
  endfor
  mircx_data(*,*,i)=temp/numz
  for base=0,5 do begin ; nbaselines
  for k=0,dimy-1 do begin
    boot_mean,tempv2(base,*,k),100,mv2
    vis2_base(base,k,i,*)=[median(mv2),stdev(mv2)]
    boot_mean,tempv2_bias(base,*,k),100,mv2
    vis2_bias(base,k,i,*)=[median(mv2),stdev(mv2)]
  endfor
  endfor
  for tri=0,3 do begin ;ntri
   for k=0,dimy-1 do begin
     temp=boot_xyangles( float(temptp(tri,*,k)), imaginary(temptp(tri,*,k)), res=res)
     cp_tri(tri,k,i,*)=res
     temp=boot_xyamp( float(temptp(tri,*,k)), imaginary(temptp(tri,*,k)), res=res)
     tp_tri(tri,k,i,*)=res/numz
   endfor
  endfor
     ;***  defer TP.

endfor
;-------------------------
if (keyword_set(nophotometry) ne 1) then begin
  ps_norms_chop=(total((ps_norms_chop),1))^2
  ps_norms_shut=(total((ps_norms_shut),1))^2
  ps_norms_fiber=(total((ps_norms_fiber),1))^2
  ps_norms_chop = transpose( ps_norms_chop,[1,0,2])
  ps_norms_shut = transpose( ps_norms_shut,[1,0,2])
  ps_norms_fiber= transpose( ps_norms_fiber,[1,0,2])
endif


end
