; mirc_linfit
;
; This does a least squares fit a la numerical recipes.
; Useful to get first order term from non-destructive reads.
; Assumes all points have same noise.

function mirc_linfit, y

   N= double(n_elements(y))
   x=dindgen(n)+1d0
   C1 = 0.5d0*(N + 1);
   C2 = 12./(N*(N*N - 1.));
   value = total( y* (x-c1))*c2

return,value
end
