; mirc_linfit3d
;
; This does a least squares fit a la numerical recipes.
; Useful to get first order term from non-destructive reads.
; Assumes all points have same noise.
;
;   data input is (x,y,num_reads)
;  will output an array (x,y)

function mirc_linfit3d, datacube

info=size(datacube,/dim)
dimx=info(0)
dimy=info(1)
dimz=info(2)

N= double(dimz)

x=rebin(reform(dindgen(n)+1d0,1,1,dimz),dimx,dimy,dimz)
C1 = 0.5d0*(N + 1);
C2 = 12./(N*(N*N - 1.));
value = total( (datacube* (x-c1)) ,3)*c2

return,value
end
