; 2007Aug25 JDM  fit for slope.
; 2006Dec21 JDM  Helper for mirc_process3a.
; requires 3-dimensional arrays.... (x,y,z) where loop for values i over z.

pro mirc_photohelper2_slope, profiles, $   dimx,dimy,dimz
  profile_b1,profile_b2,profile_b3,profile_b4, $
  outs_b1,outs_b2,outs_b3,outs_b4,outs_data,chi2s=chi2s,$
  fluxes = fluxes, slopes=slopes, $
  bestfp =bestfp, $
  ffwid = ffwid

if keyword_set(ffwid) eq 0 then ffwid=1.0 ; # of pixels for the FWHM in the fourier filter
;	used in conjunction with bestfp

;OPTIONAL
; best fp =   pixels per fringe array. used for doing FFT FILTERING

ntel=4
dims=size(profiles,/dim)
ndim=n_elements(dims)
if (ndim ne 3) then begin
  print,'must be ndim 3 or wont work in current version'
  return
endif

dimx=dims(0)
dimy=dims(1)
dimz=dims(2)

temp=profiles
n=dimz
temp2 =fltarr(ntel,n)
temp3 = fltarr(n)

starts = [1.0,1,1,1,0,0,0,0]
;parinfo = replicate({},ntel*2)

outs_b1 =fltarr(dimx,dimy,n)
outs_b2 =fltarr(dimx,dimy,n)
outs_b3 =fltarr(dimx,dimy,n)
outs_b4 =fltarr(dimx,dimy,n)
outs_data =fltarr(dimx,dimy,n)
chi2s = fltarr(n)
fluxes=fltarr(ntel,n)
slopes=fltarr(ntel,n)

pb1= profile_b1
pb2= profile_b2
pb3= profile_b3
pb4= profile_b4


if keyword_set(bestfp) eq 1 then begin ; setup fft filter
 ff = shift(findgen(dimx)-dimx/2,-dimx/2)
 wf =fltarr(dimx,dimy)
 wf(*)=1.0
 nbase = (size(bestfp,/dim))(0)
 for j=0,dimy-1 do begin
   for k=0,nbase-1 do begin
      tempf = exp( -(ff-(dimx/bestfp(k,j)))^2/(ffwid*ffwid))
      tempf=tempf/max(tempf)
      wf(*,j) = wf(*,j)*(1.-tempf)

      tempf = exp( -(ff+(dimx/bestfp(k,j)))^2/(ffwid*ffwid))
      tempf=tempf/max(tempf)
      wf(*,j) = wf(*,j)*(1.-tempf)
   endfor
 ; First filter the profiles if necessary to save time.
   pb1(*,j)=fft_filter(pb1(*,j),wf(*,j))
   pb2(*,j)=fft_filter(pb2(*,j),wf(*,j))
   pb3(*,j)=fft_filter(pb3(*,j),wf(*,j))
   pb4(*,j)=fft_filter(pb4(*,j),wf(*,j))
 endfor
image_cont,wf,/noc
endif   



for i=0,n-1 do begin

  tp=temp(*,*,i)

 if  keyword_set(bestfp) eq 1 then begin ;  fft filter
   for j=0,dimy-1 do begin
     tp(*,j) =fft_filter(tp(*,j),wf(*,j))
   endfor
endif



  fa={profile_b1:pb1,profile_b2:pb2, profile_b3:pb3,profile_b4:pb4,$
      profile_data:tp}

  starts = [total(tp)/total(pb1)/ntel, total(tp)/total(pb2)/ntel, $
            total(tp)/total(pb3)/ntel, total(tp)/total(pb4)/ntel, $
            0.0, 0, 0, 0]
;stop
nparms=n_elements(starts)
parinfo = replicate({value:0.D, fixed:0, limited:[0,0], $
                                  limits:[0.D,0],step:0d0,relstep:0.d0,tied:''}, nparms)

; limit slopes to +/- 25%
parinfo(4:7).limited=[1,1]
parinfo(4:7).limits=[-.25,.25]

; limit flux to be positive..... which is physical!
  parinfo(0:3).limited=[1,0]  
  parinfo(0:3).limits=[0.0,0]

  result = mpfit('mpfunc_4beams',starts,functargs = fa,/quiet,parinfo=parinfo)

; OUTPUT will be the synthesized out_data using the
;UNFILTERED profiles.

;  resid = mpfunc_4beams( result,$
;  profile_b1 = pb1, $
;  profile_b2 = pb2, $
;  profile_b3 = pb3, $
;  profile_b4 = pb4, $
;  profile_data = tp,$
;  out_b1 = out_b1, $
;  out_b2 = out_b2, $
;  out_b3 = out_b3, $
;  out_b4 = out_b4, $
;  out_data = out_data)

  resid = mpfunc_4beams( result,$
  profile_b1 = profile_b1, $
  profile_b2 = profile_b2, $
  profile_b3 = profile_b3, $
  profile_b4 = profile_b4, $
  profile_data = temp(*,*,i),$
  out_b1 = out_b1, $
  out_b2 = out_b2, $
  out_b3 = out_b3, $
  out_b4 = out_b4, $
  out_data = out_data)




  chi2s(i) = total(resid*resid)/n_elements(resid)
  outs_b1(*,*,i)=out_b1
  outs_b2(*,*,i)=out_b2
  outs_b3(*,*,i)=out_b3
  outs_b4(*,*,i)=out_b4
  outs_data(*,*,i)=out_data
  fluxes(*,i) = result(0:(ntel-1))
  slopes(*,i) = result( ntel:(2*ntel-1))

endfor


end

