;  2007Aug24 JDM	 original


; helps to project a vector with errors against a acertain direction
; returns projected component with errors.

pro mirc_projection, amps, amps_err, phase,phase_err, phase0,$ ; INPUt
   projamp,projamp_err ; OUTPUT
; all angles in degrees

; phase0 must be a single element
phase00=phase0(0)

rp=reform(amps*cos(phase*!pi/180))
ip=reform(amps*sin(phase*!pi/180))

l2=rp^2+ip^2
in=where(l2 eq 0,ct)
if ct ge 1 then l2(in)=1.0 ; nosignal
rp0=rp/sqrt(l2) ; unit vector
ip0=ip/sqrt(l2) 

rp_err_amp = reform(rp0*amps_err)
ip_err_amp = reform(ip0*amps_err)

rp_err_phase =  reform(ip0*amps*tan(phase_err*!pi/180.))
ip_err_phase = reform(-rp0*amps*tan(phase_err*!pi/180.))

rp_proj = (cos(phase00*!pi/180.))
ip_proj = (sin(phase00*!pi/180.))


vals = rp_proj*rp + ip_proj*ip
err_amp = rp_proj*rp_err_amp + ip_proj*ip_err_amp
err_phase=rp_proj*rp_err_phase+ip_proj*ip_err_phase

errs = sqrt( err_amp*err_amp+err_phase*err_phase)

projamp=vals
projamp_err=errs

return
end
