; 2003Jun28 JDM, created for keck->oidata
; 2003Jun30 JDM modified for iota-fluor
; 2300Sep24 JDM modified for IONIC3 data [still not ARRAYS, only data.]
; 2004Jun08 JDM modified for new version of software
;	    (3 I1-I2 channels, multiple targets, still no oi-arrays)
; 2004Jun28 JDM fixed bug (ra was in hrs, not degrees as called for in standard)
; 2006Sep14 JDM modified for CHARA-MIRC 
;	still not including oi-array (but will!, I promise)
; 2006Dec03 JDM mirc2oidata -> mircfull2oidata
;	    new features: each baseline and triangle has its own time/uv info.
; 2006Dec10 JDM. currently only one target per call int his file --
;           however, this could easily be fixed by expanding the
;           definition of vis2_oifits,t3_oifits

; * as of now I have not
;confirmed closure phase sign for CHARA/MIRC (HIGH ON LIST !) 
; 2006Sep14 
;
; 
pro mircfull2oidata, obs_date0,ra,dec, target,$
    vis2_oifits, t3_oifits,$
    specname, lambda,lambdaerr,telindex,file=file

; JDM 2006

;vis2_oifits = {      uu_meters : dblarr(nbaselines),$
;               vv_meters : dblarr(nbaselines),$
;               obs_time  : dblarr(nbaselines),$ ; might be diff per baseline
;               int_time  : dblarr(nbaselines),$ ; due to data selection
;               mjd       : dblarr(nbaselines),$ ;
;               vis2      : fltarr(nbaselines,dimy),$
;               vis2_err  : fltarr(nbaselines,dimy),$
;               badflag   : intarr(nbaselines,dimy),$
;               telindex1 : intarr(nbaselines), $
;               telindex2 : intarr(nbaselines), $
;               nbaselines: nbaselines,$
;               dimy      : dimy}
;t3_oifits= {      uu1_meters : dblarr(ntriangles),$
;               vv1_meters : dblarr(ntriangles),$
;               uu2_meters : dblarr(ntriangles),$
;               vv2_meters : dblarr(ntriangles),$
;               obs_time  : dblarr(ntriangles),$ ; might be diff per baseline
;               int_time  : dblarr(ntriangles),$ ; due to data selection
;               mjd       : dblarr(ntriangles),$
;               t3amp      : fltarr(ntriangles,dimy),$
;               t3amp_err  : fltarr(ntriangles,dimy),$
;               t3phi      : fltarr(ntriangles,dimy),$
;               t3phi_err  : fltarr(ntriangles,dimy),$
;               badflag_t3amp   : intarr(ntriangles,dimy),$
;               badflag_t3phi   : intarr(ntriangles,dimy),$
;               telindex1    : intarr(ntriangles), $
;               telindex2    : intarr(ntriangles), $
;               telindex3    : intarr(ntriangles), $
;               ntriangles: ntriangles,$
;               dimy      : dimy}





;obs_date '2003-02-22'
;obs_times: float UT times
;


define_oiarray,oiarray_unit
;TEL ORDER: s1,s2,e1,w1,w2,e2   ;Crazy order inherited from Theo!
; in reality, its simpler to always define the 6 chara tels.
; however! for some applications its easier to break up into 4-tel arrays.
; I will  make this an option someday
; to write all six, simply write: tin=[0,1,2,3,4,5]
tin=telindex
ntel=n_elements(tin)
tnames=strarr(ntel)
for i=0,ntel-1 do begin
 if tin(i) eq 0 then tnames(i)='S1'
 if tin(i) eq 1 then tnames(i)='S2'
 if tin(i) eq 2 then tnames(i)='E1'
 if tin(i) eq 3 then tnames(i)='W1'
 if tin(i) eq 4 then tnames(i)='W2'
 if tin(i) eq 5 then tnames(i)='E2'
endfor
ssin=sort(tin)
grab_chara_uv,ha=[0.01],dec=0.0,xyz=xyz
;view 

oiarray=replicate(oiarray_unit,ntel)

oiarray.extver=1
oiarray.arrname="CHARA"
oiarray.frame = "GEOCENTRIC"
oiarray.arrayx =  0.0
oiarray.arrayy =  0.0
oiarray.arrayz =  0.0
oiarray.tel_name = tnames(ssin) 
oiarray.sta_name = tnames(ssin)
oiarray.sta_index = tin(ssin)
oiarray.diameter = 1.0

for i=0,ntel-1 do begin
oiarray(i).staxyz = reform(xyz(*,tin(ssin(i))))
endfor

skip_array:
;-----------------------------------------
define_oitarget,oitarget_unit

;find uniq targets
uniq_in=uniq(target,sort(target))
ntargets=n_elements(uniq_in)

oitarget=replicate(oitarget_unit,ntargets)
targetnums=intarr(n_elements(target))
 ; this file will not work for multiple targets! [jdm 2006Dec10]

for i=0,ntargets-1 do begin
ti=uniq_in(i)
ins=where(target eq target(ti))
targetnums(ins)=i

oitarget(i).target_id = i
oitarget(i).target = target(ti)
oitarget(i).raep0 = ra(ti) ; DEGREES
oitarget(i).decep0 = dec(ti)
oitarget(i).equinox = 2000.0
oitarget(i).ra_err = -1
oitarget(i).dec_err = -1
oitarget(i).sysvel = -1
oitarget(i).veltyp = ["LSR"]
oitarget(i).veldef = ["OPTICAL"]
oitarget(i).pmra = -1
oitarget(i).pmdec = -1
oitarget(i).pmra_err = -1
oitarget(i).pmdec_err = -1
oitarget(i).parallax = -1
oitarget(i).para_err=-1
oitarget(i).spectyp = ["Unknown"]

endfor
;-------------------------------------------
nwave=n_elements(lambda)
define_oiwavelength,oiwavelength_unit,nwave=nwave
 oiwavelength=oiwavelength_unit
 oiwavelength.extver=1
 oiwavelength.insname=specname
 oiwavelength.eff_wave = ptr_new(lambda) ; average of spectral channel
 oiwavelength.eff_band = ptr_new(lambdaerr)

;define_oiwavelength,oiwavelength_unit,nwave=20
; oiwavelength=concat_oitable(oiwavelength,oiwavelength_unit)
; oiwavelength(1).extver=1
;oiwavelength(1).insname="CHARA_MIRC"
;oiwavelength(1).eff_wave = ptr_new( (findgen(20)/20+1.4)*1e-6)
;oiwavelength(1).eff_band = ptr_new( replicate(.05,20)*1e-6 )
;
;-----------------------------------------------------
;NO OIVIS
goto,skip_oivis
nwave=n_elements(lambda)
define_oivis, oivis_unit, nwave= nwave
oivis=replicate(oivis_unit,9)
oivis(*).extver=1
oivis(*).date_obs='2002-12-17'
oivis(*).arrname ="IOTA_2002Dec17"
oivis(*).insname ="IOTA_IONIC_PICNIC"
oivis(*).target_id = [0,0,0,1,1,1,0,0,0]
oivis(*).time = 100*findgen(9)
oivis(*).mjd   = 100*findgen(9)/3600./24.
oivis(*).int_time = 20.
for i=0,8 do begin
 oivis(i).visamp =ptr_new(i/10.)
 oivis(i).visamperr = ptr_new(.05)
 oivis(i).visphi = ptr_new(i*10.)
 oivis(i).visphierr = ptr_new(10.)
 oivis(i).ucoord    = i*10.
 oivis(i).vcoord    = -i*10.
 oivis(i).sta_index  = [i mod 3, (i+1) mod 3 ]
 if (i mod 2) then oivis(i).flag       = ptr_new(byte("T")) $
             else  oivis(i).flag = ptr_new(byte("F"))
endfor

define_oivis, oivis_unit, nwave= 20
oivis0=replicate(oivis_unit,3)
oivis0(*).extver=2
oivis0(*).date_obs='2004-01-11'
oivis0(*).arrname ="MIRC4"
oivis0(*).insname =specname
oivis0(*).target_id = [0,1,2]
oivis0(*).time = 10*findgen(3)
oivis0(*).mjd   = 10*findgen(3)/3600./24.
oivis0(*).int_time = 2.
for i=0,2 do begin
 oivis0(i).visamp =ptr_new( (i+findgen(20))/20.)
 oivis0(i).visamperr = ptr_new(replicate(.02,20))
 oivis0(i).visphi = ptr_new( findgen(20)*10+10*i )
 oivis0(i).visphierr = ptr_new(replicate(1.0,20))
 oivis0(i).ucoord    = i*50.
 oivis0(i).vcoord    = -i*50.
 oivis0(i).sta_index  = [3,5]
 if (i mod 2) then oivis0(i).flag       = ptr_new(byte("TTFFFFFTTTFFFFFFFFFF")) $
             else  oivis0(i).flag = ptr_new(byte("FFFFFTTTTTFFFFFTTTTT"))
endfor

oivis=concat_oitable(oivis,oivis0)
;--------------------------------------------------------
skip_oivis:

ntimes=n_elements(vis2_oifits)
if ntimes eq 0 then goto,skipvis2
nbaselines=vis2_oifits(0).nbaselines
if (n_elements(obs_date0) eq 1) then begin
  obs_dates=replicate(obs_date0,ntimes)
endif else obs_dates=obs_date0
jdcnv,strmid(obs_dates,0,4),strmid(obs_dates,5,2),strmid(obs_dates,8,2),$
 0.0, jd0s
in0=(where(jd0s eq min(jd0s)))(0)
official_obs_date = obs_dates(in0)

; Each baseline gets one Table.

numvis2tables=0
for b=0,nbaselines-1 do begin
times=24.0d0*3600.d0*(jd0s-jd0s(in0)) + vis2_oifits.obs_time(b)
vis2=reform(vis2_oifits.vis2(b,*))
vis2_err=reform(vis2_oifits.vis2_err(b,*))

; First do a little purging.
; if all the flags for a particular time/baseline are 1 then
; don't bother writing!
tempflag=reform(vis2_oifits(*).badflag(b,*) )
tempflag = total(tempflag,1)
goodin=where(tempflag ne nwave,ctgood)

if ctgood gt 0 then begin
numvis2tables=numvis2tables+1

define_oivis2, oivis2_unit, nwave= nwave

oivis2=replicate(oivis2_unit,ctgood)
oivis2(*).extver=1
oivis2(*).date_obs=official_obs_date
oivis2(*).arrname ="CHARA"
oivis2(*).insname = specname
oivis2(*).target_id = targetnums(0) ; will fail for multi-target files!!
oivis2(*).time = times (goodin)
oivis2(*).mjd   = vis2_oifits(goodin).mjd(b)
oivis2(*).int_time = vis2_oifits(goodin).int_time(b)
for i=0,ctgood-1 do begin
 ii=goodin(i)
 oivis2(i).vis2data =ptr_new(reform(vis2(*,ii))) ; vector if many lambdas
 oivis2(i).vis2err = ptr_new(reform(vis2_err(*,ii)))
 oivis2(i).ucoord    = vis2_oifits(ii).uu_meters(b) 
 oivis2(i).vcoord    = vis2_oifits(ii).vv_meters(b)
 oivis2(i).sta_index  = [vis2_oifits(ii).telindex1(b),$
                         vis2_oifits(ii).telindex2(b)]
 flagstring=makeflagstring(reform(vis2_oifits(ii).badflag(b,*) ) )
 oivis2(i).flag = ptr_new(byte(flagstring))
endfor

if numvis2tables eq 1 then oivis2_all=oivis2 else $
  oivis2_all=concat_oitable(oivis2_all,oivis2)
endif

endfor ;baseline

skipvis2:
;-------------------------------------------------
ntimes=n_elements(t3_oifits)
if ntimes eq 0 then goto,skipt3
ntriangles=t3_oifits(0).ntriangles
if (n_elements(obs_date0) eq 1) then begin
  obs_dates=replicate(obs_date0,ntimes)
endif else obs_dates=obs_date0
jdcnv,strmid(obs_dates,0,4),strmid(obs_dates,5,2),strmid(obs_dates,8,2),$
 0.0, jd0s
in0=(where(jd0s eq min(jd0s)))(0)
official_obs_date = obs_dates(in0)

; Each Triangle gets one Table.
numt3tables=0
for t=0,ntriangles-1 do begin
times=24.0d0*3600.d0*(jd0s-jd0s(in0)) + t3_oifits.obs_time(t)
t3amp=reform(t3_oifits.t3amp(t,*))
t3amp_err=reform(t3_oifits.t3amp_err(t,*))
t3phi=reform(t3_oifits.t3phi(t,*))
t3phi_err=reform(t3_oifits.t3phi_err(t,*))

; First do a little purging.
; if all the flags for a particular time/baseline are 1 then
; don't bother writing!
tempflag=reform(t3_oifits(*).badflag_t3phi(t,*) )
tempflag = total(tempflag,1)
goodin=where(tempflag ne nwave,ctgood)

if ctgood gt 0 then begin
numt3tables=numt3tables+1

define_oit3, oit3_unit, nwave=nwave

oit3=replicate(oit3_unit,ctgood)
oit3(*).extver=1
oit3(*).date_obs=official_obs_date
oit3(*).arrname ="CHARA"
oit3(*).insname =specname
oit3(*).target_id = targetnums(0)  ; will fail for multi-target files!!
oit3(*).time = times(goodin)
oit3(*).mjd   = t3_oifits(goodin).mjd(t)
oit3(*).int_time = t3_oifits(goodin).int_time(t)
; *** SIGN OF CLOSURE PHASE TRIANGLE NOT KNOWN HERE YET!!!!
; 2006Sep15
for i=0,ctgood-1 do begin
 ii=goodin(i)
 oit3(i).t3amp =ptr_new(reform(t3amp(*,ii)))
 oit3(i).t3amperr = ptr_new(reform(t3amp_err(*,ii)))
 oit3(i).t3phi = ptr_new( reform(t3phi(*,ii)))
 oit3(i).t3phierr = ptr_new( reform(t3phi_err(*,ii)))
 oit3(i).u1coord    = t3_oifits(ii).uu1_meters(t)
 oit3(i).v1coord    = t3_oifits(ii).vv1_meters(t)
 oit3(i).u2coord    = t3_oifits(ii).uu2_meters(t)
 oit3(i).v2coord    = t3_oifits(ii).vv2_meters(t)
 oit3(i).sta_index  = [t3_oifits(ii).telindex1(t),$
                       t3_oifits(ii).telindex2(t),$
                       t3_oifits(ii).telindex3(t)]
 flagstring=makeflagstring(reform(t3_oifits(ii).badflag_t3phi(t,*) )) 
;print,flagstring
 oit3(i).flag  = ptr_new(byte(flagstring))
endfor ;a ll time stamps
 if numt3tables eq 1 then oit3_all=oit3 else $
  oit3_all=concat_oitable(oit3_all,oit3)
endif ;ctgood>0

endfor ; triangles
;stop
;----------------------------

skipt3:

write_oidata,file,oiarray,oitarget,oiwavelength,oivis,oivis2_all,oit3_all
end



