
function mpfunc_4beams, params,$
  profile_b1 = profile_b1, $
  profile_b2 = profile_b2, $
  profile_b3 = profile_b3, $
  profile_b4 = profile_b4, $
  profile_data = profile_data,$
  out_b1 = out_b1, $
  out_b2 = out_b2, $
  out_b3 = out_b3, $
  out_b4 = out_b4, $
  out_data = out_data

ntel=4
; params  =  flux_b1, flux_b2, flux_b3,flux_b4, $
;             slope_b1,slope_b2,slope_b3,slope_b4

fluxes= params(0:(ntel-1))
slopes = params(ntel:(2*ntel-1))
; profiles = [dimx, dimy] : dimy is the spectral direction. 

dims = size(profile_b1,/dim)
dimx=dims(0)
dimy=dims(1)

;vals_b1 = (findgen(dimy)-dimy/2.0)*slopes(0) + fluxes(0)
;vals_b2 = (findgen(dimy)-dimy/2.0)*slopes(1) + fluxes(1)
;vals_b3 = (findgen(dimy)-dimy/2.0)*slopes(2) + fluxes(2)
;vals_b4 = (findgen(dimy)-dimy/2.0)*slopes(3) + fluxes(3)
; the following slope is unitless.. so a slope of +1 means that
;the flux actually goes to zero at channel 0.
; for slope -1 hen flux goes to zero at channel dimy-1.
; values should always be between these extremes!! ideally < 0.5

vals = pvector([-1,1,dimy])
vals_b1 = (vals*slopes(0)+1.0)*fluxes(0)
vals_b2 = (vals*slopes(1)+1.0)*fluxes(1)
vals_b3 = (vals*slopes(2)+1.0)*fluxes(2)
vals_b4 = (vals*slopes(3)+1.0)*fluxes(3)



vals_b1 = rebin(reform(vals_b1,1,dimy),dimx,dimy)
vals_b2 = rebin(reform(vals_b2,1,dimy),dimx,dimy)
vals_b3 = rebin(reform(vals_b3,1,dimy),dimx,dimy)
vals_b4 = rebin(reform(vals_b4,1,dimy),dimx,dimy)

out_b1 = profile_b1 * vals_b1
out_b2 = profile_b2 * vals_b2
out_b3 = profile_b3 * vals_b3
out_b4 = profile_b4 * vals_b4
out_data = out_b1+out_b2+out_b3+out_b4

resids = [profile_data - out_data]



return,resids(*)

 end 


