;JDM 2008May27


; Will return the merit function for global fit of calibrator sizes.
;
;
; There will 3 terms that will have user-adjustable weights.

;  vis2 :   
;  closure amplitude: 
;  prior [based on expected size of cals]

; functargs: will be needed
;     vis2data:  



function mpfunc_calstudy, calsize_params, $
     calname=calname,calsize_prior=calsize_prior,calsizeerr_prior=calsizeerr_prior,$
     vis2data=vis2data0

maxchi2 = 5 ; robustness
wts_vis2=1.
wts_clamp=1e-5
wts_prior=1./n_elements(calsize_params)

;avoid using structure directlty since they are expensive

sfus = vis2data0.sfu
lambdas=vis2data0.eff_wave
vis2 = vis2data0.vis2data
tempvis2= vis2

vis2err = vis2data0.vis2err
temp_vis2err=vis2err
target = vis2data0.target
mjd = vis2data0.mjd
sysvis2=vis2
baseline= intarr(n_elements(sfus))
sta0=vis2data0.sta_index[0] + 1
sta1=vis2data0.sta_index[1] + 1
sta_low = sta0<sta1
sta_hi  = sta0>sta1
baselines = 10*(sta0<sta1) + (sta0>sta1)

; First go through and do a global correction for the calsize_params
for i=0,n_elements(calname)-1 do begin
  in=where(target eq calname(i),ct)
  if ct eq 0 then begin
    print,calname(i),' does not exist in file!!!'
    stop
  endif 
  uniform_disk,sfus(in),[mas2rad(calsize_params[i]),1.0],vis_cal
  vis2[in] = vis2[in]/(vis_cal*vis_cal)
  vis2err[in]=vis2err[in]/(vis_cal*vis_cal)
endfor


nights = fix(mjd)-min(fix(mjd))
unights = nights(uniq(nights,sort(nights)))
n_nights =n_elements(unights)

ncal = n_elements(calname)

calcal_vis2 = fltarr(ncal,ncal)
calcalnights_vis2 = fltarr(ncal,ncal,n_nights)
calcal_clamp = fltarr(ncal,ncal)
calcalnights_clamp = fltarr(ncal,ncal,n_nights)

; to make the results tractable I will do this cal x cal pair.

;for c0=0,ncal-2 do begin
;; for c1=c0+1,ncal-1 do begin
for c0=0,ncal-1 do begin
for c1=0,ncal-1 do begin

; First, go through and for each night and calc sysvis for each lambda & baseline
nightcounter=0
for n=0,n_nights-1 do begin
  in_c0 = where(nights eq unights(n) and target eq calname(c0),ct_c0)
  in_c1 = where(nights eq unights(n) and target eq calname(c1),ct_c1)
if (ct_c0 gt 0 and ct_c1 gt 0) then begin
  nightcounter=nightcounter+1
  baseline = baselines[[in_c0,in_c1]]
  ubaseline = baseline(uniq(baseline,sort(baseline)))
  ubaseline= ubaseline(sort(ubaseline))
  n_baseline = n_elements(ubaseline)


  lambda = lambdas[[in_c0,in_c1]]
  ulambda = lambda(uniq(lambda,sort(lambda)))
  n_lambda = n_elements(ulambda)
  ratios = fltarr(n_lambda,n_baseline)
  ratios_errs= fltarr(n_lambda,n_baseline)
  if n_baseline eq 6 then begin
     cl_ratios = fltarr(n_lambda,3)
     cl_ratios_errs = fltarr(n_lambda,3)
  endif
  for l=0,n_lambda-1 do begin

   for b=0,n_baseline-1 do begin
     in0 = where(nights eq unights(n) and target eq calname(c0) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[b],ct0)
     in1 = where(nights eq unights(n) and target eq calname(c1) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[b],ct1)
     if ct0 gt 0 and ct1 gt 0 then begin
    
     numer = wtd_mean( vis2[in0],vis2err[in0],we0)
     denom = wtd_mean( vis2[in1],vis2err[in1],we1)
 
     endif else begin
       numer=1
       denom=1.
       we0=1.0
       we1=1.0
     endelse
     
     ratios[l,b] = numer/denom
     ratios_errs[l,b] = (numer/denom)* ( (we0/numer) + (we1/denom) )



   endfor


   ; also count clamp
   if n_baseline eq 6 then begin ; do closure amplitude!
    ;clamps are going to be 3 closure amps to compare.
      for ca=0,2 do begin
        if ca eq 0 then begin
          numer_in=[0,5]
          denom_in=[1,4]
	endif
       if ca eq 1 then begin
          numer_in=[0,5]
          denom_in=[2,3]
        endif
       if ca eq 2 then begin
          numer_in=[1,4]
          denom_in=[2,3]
        endif
       in0 = where(nights eq unights(n) and target eq calname(c0) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[numer_in[0]],ct0)
       in1 = where(nights eq unights(n) and target eq calname(c0) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[numer_in[1]],ct1)
       in2 = where(nights eq unights(n) and target eq calname(c0) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[denom_in[0]],ct2)
       in3 = where(nights eq unights(n) and target eq calname(c0) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[denom_in[1]],ct3)
       if ct0 gt 0 and ct1 gt 0 and ct2 gt 0 and ct3 gt 0 then begin
       
       numer0 = wtd_mean(vis2[in0],vis2err[in0],we0)
       numer1 = wtd_mean(vis2[in1],vis2err[in1],we1)
       denom0 = wtd_mean(vis2[in2],vis2err[in2],we2)
       denom1 = wtd_mean(vis2[in3],vis2err[in3],we3)
	endif else begin
 	numer0=1.
        numer1=1
	denom0=1
        denom1=1
        we0=1
        we1=1
        we2=1
        we3=1.
	endelse
       in0 = where(nights eq unights(n) and target eq calname(c1) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[numer_in[0]],ct0)
       in1 = where(nights eq unights(n) and target eq calname(c1) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[numer_in[1]],ct1)
       in2 = where(nights eq unights(n) and target eq calname(c1) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[denom_in[0]],ct2)
       in3 = where(nights eq unights(n) and target eq calname(c1) and $
           lambdas eq ulambda[l] and baselines eq ubaseline[denom_in[1]],ct3)

           if ct0 gt 0 and ct1 gt 0 and ct2 gt 0 and ct3 gt 0 then begin
       numer0c = wtd_mean(vis2[in0],vis2err[in0],we0c)
       numer1c = wtd_mean(vis2[in1],vis2err[in1],we1c)
       denom0c = wtd_mean(vis2[in2],vis2err[in2],we2c)
       denom1c = wtd_mean(vis2[in3],vis2err[in3],we3c)
	endif else begin
        numer0c=1.
        numer1c=1
        denom0c=1
        denom1c=1
        we0c=1
        we1c=1
        we2c=1
        we3c=1.
        endelse


       cl_ratios[l,ca] = numer0*numer1*denom0c*denom1c/$
                        (denom0*denom1*numer0c*numer1c)  
       cl_ratios_errs[l,ca] = cl_ratios[l,ca] * $
                              ((we0/numer0) + (we1/numer1) + (we2/denom0) + (we3/denom1) +$
                               (we0c/numer0c) +(we1c/numer1c)+(we2c/denom0c)+(we3c/denom1c) )/4.

      endfor
    endif


endfor; lambda

calcalnights_vis2[c0,c1,n] = total(((ratios-1.0)/ratios_errs)^2 ) / n_elements(ratios_errs)
calcalnights_clamp[c0,c1,n] = total(((cl_ratios-1.0)/cl_ratios_errs)^2 ) / n_elements(cl_ratios_errs)

endif ; both cals exist on that night

endfor; n_nights

; apply a max chi2 for 'robustness' -- turns logarthimic
in=where(calcalnights_vis2 gt maxchi2,ct)
if ct gt 0 then calcalnights_vis2(in) = maxchi2+alog10(calcalnights_vis2(in)/maxchi2)
in=where(calcalnights_clamp gt maxchi2,ct)
if ct gt 0 then calcalnights_clamp(in) = maxchi2+alog10(calcalnights_clamp(in)/maxchi2)


if nightcounter gt 0 then begin
calcal_vis2[c0,c1] = total(calcalnights_vis2[c0,c1,*])/nightcounter
calcal_clamp[c0,c1] = total(calcalnights_clamp[c0,c1,*])/nightcounter
endif
endfor; c1
endfor; c0

in1=where(calcal_vis2 gt 0,ct1)
in2=where(calcal_clamp gt 0,ct2)

chi2_vis2 = total(calcal_vis2)/ct1
chi2_clamp = total(calcal_clamp)/ct2

chi_prior = (calsize_params - calsize_prior)/calsizeerr_prior
;chi2_prior=total(chi_prior*chi_prior)/n_elements(calsize_params)

result =[wts_vis2*chi2_vis2,wts_clamp*chi2_clamp,wts_prior*chi_prior]
;stop
return,result

end

